Structure condition
    Dim Length As Long
    Dim Command As Long
    Dim Bytes() As Byte
End Structure


Structure action
    Dim Length As Long
    Dim Command As Long
    Dim Bytes() As Byte
End Structure
Structure Record
    Dim If_Else As Byte
    Dim Conditioncount As Long
    Dim Conditions() As condition
    Dim Actioncount As Long
    Dim Actions() As action
    Dim Recordname As String
    Dim RecordNameBytes() As Byte
End Structure

Structure Block
    Dim BlockName As String
    Dim BlockNameBytes() As Byte
    Dim RecordCount As Long
    Dim Records() As Record
End Structure


Public Class Form1
    Dim Blocks(50) As Block
    Dim ThisRecord As Record
    Dim File_Version As Long
    Dim BlockCount As Long
    Dim AIPTimer As Long
    Dim Chance As Long
    Dim ReadOffSet As Long
    Dim AIPName As String
    Dim AIPNameBytes(100) As Byte
    Dim NameLen As Long
    Dim readpos As Long

    Dim dp As Byte
    Dim BlockIndex As Long
    Dim RecordIndex As Long
    Dim ActionIndex As Long
    Dim CondIndex As Long
    Dim RefVar As String
    Dim WorldVar As Integer
    Dim EconomyVar As Integer
    Public OpMode As Integer
    Dim TBL(50) As Byte
    Dim ThisCondOpCode As Integer
    Dim ThisActionOpCode As Integer
    Dim CondFormat(20) As Integer
    Dim ActionFormat(20) As Integer
    Dim TempCondBytes(50) As Byte
    Dim TempCondByteCount As Integer
    Dim TempActionBytes(50) As Byte
    Dim TempActionByteCount As Integer

    'Data addressing information for writing to the Byte Arrays
    Dim CondDataLabel1_start As Integer
    Dim CondDataLabel1_len As Integer
    Dim CondDataLabel2_start As Integer
    Dim CondDataLabel2_len As Integer
    Dim CondDataLabel3_start As Integer
    Dim CondDataLabel3_len As Integer
    Dim CondDataLabel4_start As Integer
    Dim CondDataLabel4_len As Integer
    Dim CondDataLabel5_start As Integer
    Dim CondDataLabel5_len As Integer
    Dim CondbtOp1_start As Integer
    Dim CondbtOp1_len As Integer
    Dim CondTF1_start As Integer
    Dim CondTF1_len As Integer
    Dim ActionDataLabel1_start As Integer
    Dim ActionDataLabel1_len As Integer
    Dim ActionDataLabel2_start As Integer
    Dim ActionDataLabel2_len As Integer
    Dim ActionDataLabel3_start As Integer
    Dim ActionDataLabel3_len As Integer
    Dim ActionDataLabel4_start As Integer
    Dim ActionDataLabel4_len As Integer
    Dim ActionDataLabel5_start As Integer
    Dim ActionDataLabel5_len As Integer
    Dim ActionDataLabel6_start As Integer
    Dim ActionDataLabel6_len As Integer
    Dim ActionDataLabel7_start As Integer
    Dim ActionDataLabel7_len As Integer
    Dim ActionOption1_start As Integer
    Dim ActionOption1_len As Integer
    Dim ActionAS1_start As Integer
    Dim ActionAS1_len As Integer
    Dim ActionSOption1_start As Integer
    Dim ActionSOption1_len As Integer
    Dim ActionQOption1_start As Integer
    Dim ActionQOption1_len As Integer
    Dim ActionbtOp1_start As Integer
    Dim ActionbtOp1_len As Integer
    Dim ActionTF1_start As Integer
    Dim ActionTF1_len As Integer
    Dim ActionCombo2_start As Integer
    Dim ActionCombo2_len As Integer
    Dim ActionCombo3_start As Integer
    Dim ActionCombo3_len As Integer
    Dim ActionCombo4_start As Integer
    Dim ActionCombo4_len As Integer


    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        'Load a AIP file
        Dim a As Integer
        Dim n As Integer
        Dim i As Long
        Dim j As Long
        Dim k As Long
        Dim l As Long
        Dim filepath As String

        'clear listbox1
        ListBox1.Items.Clear()

        OpenFileDialog1.FileName = ""
        OpenFileDialog1.Title = "Import AIP file."
        OpenFileDialog1.Filter = "ROSE AIP Files (*.AIP)|*.AIP"
        OpenFileDialog1.ShowDialog()
        filepath = OpenFileDialog1.FileName

        If filepath = "" Then Exit Sub 'detect cancel
        TextBox1.Text = filepath

        Dim fs As System.IO.FileStream
        Dim r As System.IO.BinaryReader
        Dim mylength As Long
        fs = New System.IO.FileStream(filepath, IO.FileMode.OpenOrCreate)
        r = New System.IO.BinaryReader(fs)
        mylength = fs.Length
        If mylength = 0 Then
            MsgBox("File has zero length so cannot be loaded")
            Exit Sub
        End If

        BlockCount = r.ReadUInt32
        AIPTimer = r.ReadUInt32
        Chance = r.ReadUInt32
        'ReadOffSet = r.ReadUInt32
        Timer.Text = AIPTimer
        NameLen = r.ReadUInt32
        a = a
        AIPName = ""
        For n = 1 To NameLen
            dp = r.ReadByte
            AIPNameBytes(n) = dp
            a = a
            AIPName += Chr(dp)
        Next n
        a = a
        
        For i = 1 To BlockCount
            Blocks(i).BlockNameBytes = New Byte(32) {}

            Blocks(i).BlockName = ""
            For n = 0 To 31
                dp = r.ReadByte
                Blocks(i).BlockNameBytes(n) = dp
                Blocks(i).BlockName += Chr(Blocks(i).BlockNameBytes(n))
            Next n
            Blocks(i).RecordCount = r.ReadUInt32
            Blocks(i).Records = New Record(Blocks(i).RecordCount + 1) {}
            a = a
            ListBox1.Items.Add("Block: " + CStr(i))

            For j = 1 To Blocks(i).RecordCount
                Blocks(i).Records(j).RecordNameBytes = New Byte(32) {}
                For n = 0 To 31
                    dp = r.ReadByte
                    Blocks(i).Records(j).RecordNameBytes(n) = dp
                Next n
                Blocks(i).Records(j).Conditioncount = r.ReadUInt32
                Blocks(i).Records(j).Conditions = New condition(Blocks(i).Records(j).Conditioncount + 1) {}
                a = a
                For k = 1 To Blocks(i).Records(j).Conditioncount
                    Blocks(i).Records(j).Conditions(k).Bytes = New Byte(50) {}
                    Blocks(i).Records(j).Conditions(k).Length = r.ReadUInt32    'size
                    Blocks(i).Records(j).Conditions(k).Command = r.ReadUInt32   'OpCode
                    For l = 0 To Blocks(i).Records(j).Conditions(k).Length - 9
                        Blocks(i).Records(j).Conditions(k).Bytes(l) = r.ReadByte
                    Next l
                Next k
                Blocks(i).Records(j).Actioncount = r.ReadUInt32
                Blocks(i).Records(j).Actions = New action(Blocks(i).Records(j).Actioncount + 1) {}
                a = a
                For k = 1 To Blocks(i).Records(j).Actioncount
                    Blocks(i).Records(j).Actions(k).Bytes = New Byte(50) {}
                    Blocks(i).Records(j).Actions(k).Length = r.ReadUInt32   'size
                    Blocks(i).Records(j).Actions(k).Command = r.ReadUInt32  'OpCode
                    For l = 0 To Blocks(i).Records(j).Actions(k).Length - 9
                        Blocks(i).Records(j).Actions(k).Bytes(l) = r.ReadByte
                    Next l
                Next k
            Next j
        Next i
        r.Close()
        fs.Close()
    End Sub
    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        'Save a QSD file
        Dim a, n, i, j, k, l, Writepos As Integer
        Dim filepath, msg, testname As String
        Dim TempByte, BlankByte As Byte

        BlankByte = 0

        SaveFileDialog1.FileName = ""
        SaveFileDialog1.Title = "Save AIP file."
        SaveFileDialog1.Filter = "ROSE AIP Files (*.AIP)|*.AIP"
        SaveFileDialog1.ShowDialog()
        filepath = SaveFileDialog1.FileName

        If filepath = "" Then Exit Sub 'detect cancel
        TextBox1.Text = filepath

        Dim fs As System.IO.FileStream
        Dim r As System.IO.BinaryWriter
        Dim mylength As Long
        fs = New System.IO.FileStream(filepath, IO.FileMode.Create)
        r = New System.IO.BinaryWriter(fs)
        mylength = fs.Length


        r.Write(BlockCount)
        fs.Position = 4
        r.Write(AIPTimer)
        fs.Position = 8
        r.Write(Chance)
        fs.Position = 12

        NameLen = Len(AIPName)
        r.Write(NameLen)
        Writepos = 15 'adds 1 before writing data
        For n = 0 To NameLen '- 1
            fs.Position = Writepos
            Writepos = Writepos + 1
            r.Write(AIPNameBytes(n))
        Next
        a = a

        For i = 1 To BlockCount
            For n = 0 To 31
                r.Write(Blocks(i).BlockNameBytes(n))
                'dp = r.ReadByte
                Writepos = Writepos + 1
                fs.Position = Writepos
            Next n
            r.Write(Blocks(i).RecordCount)
            Writepos = Writepos + 4
            fs.Position = Writepos
            For j = 1 To Blocks(i).RecordCount
                For n = 0 To 31
                    r.Write(Blocks(i).Records(j).RecordNameBytes(n))
                    Writepos = Writepos + 1
                    fs.Position = Writepos
                Next n
                r.Write(Blocks(i).Records(j).Conditioncount)
                Writepos = Writepos + 4
                fs.Position = Writepos
                For k = 1 To Blocks(i).Records(j).Conditioncount
                    r.Write(Blocks(i).Records(j).Conditions(k).Length)
                    Writepos = Writepos + 4
                    fs.Position = Writepos
                    r.Write(Blocks(i).Records(j).Conditions(k).Command)
                    Writepos = Writepos + 4
                    fs.Position = Writepos
                    For l = 0 To Blocks(i).Records(j).Conditions(k).Length - 9
                        r.Write(Blocks(i).Records(j).Conditions(k).Bytes(l))
                        Writepos = Writepos + 1
                        fs.Position = Writepos
                    Next l
                Next
                r.Write(Blocks(i).Records(j).Actioncount)
                Writepos = Writepos + 4
                fs.Position = Writepos
                For k = 1 To Blocks(i).Records(j).Actioncount
                    r.Write(Blocks(i).Records(j).Actions(k).Length)
                    Writepos = Writepos + 4
                    fs.Position = Writepos
                    r.Write(Blocks(i).Records(j).Actions(k).Command)
                    Writepos = Writepos + 4
                    fs.Position = Writepos
                    For l = 0 To Blocks(i).Records(j).Actions(k).Length - 9
                        r.Write(Blocks(i).Records(j).Actions(k).Bytes(l))
                        Writepos = Writepos + 1
                        fs.Position = Writepos
                    Next l
                Next k
            Next j
        Next i
        r.Close()
        fs.Close()
        MsgBox("record saved")
    End Sub

    Private Sub ListBox1_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ListBox1.SelectedIndexChanged
        Dim i As Integer
        'BlockIndex = ListBox1.ListIndex + 1
        BlockIndex = ListBox1.SelectedIndex + 1
        ListBox2.Items.Clear()
        CondList.Items.Clear()
        ActionList.Items.Clear()
        'ClearCondBytes()
        'ClearActionBytes()
        For i = 1 To Blocks(BlockIndex).RecordCount
            ListBox2.Items.Add("Record " + CStr(i) + "   " + Blocks(BlockIndex).Records(i).Recordname)
        Next i
        BlockName.Text = Blocks(BlockIndex).BlockName
        TextBox11.Text = ""
    End Sub

    Private Sub ListBox2_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ListBox2.SelectedIndexChanged
        RecordIndex = ListBox2.SelectedIndex + 1
        PopulateCondAndActionLists()
    End Sub
    Private Sub PopulateCondAndActionLists()
        Dim i As Integer
        Dim OpCode As Long
        Dim tmpString As String
        CondList.Items.Clear()
        ActionList.Items.Clear()

        RefVar = "undefined"

        ThisRecord = Blocks(BlockIndex).Records(RecordIndex)

        For i = 1 To Blocks(BlockIndex).Records(RecordIndex).Conditioncount
            OpCode = Blocks(BlockIndex).Records(RecordIndex).Conditions(i).Command
            CondList.Items.Add(GetCond(OpCode, i, 0))
        Next i

        For i = 1 To Blocks(BlockIndex).Records(RecordIndex).Actioncount
            OpCode = Blocks(BlockIndex).Records(RecordIndex).Actions(i).Command
            tmpString = GetAction(OpCode, i, 0)
            ActionList.Items.Add(tmpString)
            i = i
        Next i
        TextBox11.Text = Blocks(BlockIndex).Records(RecordIndex).Recordname
        
    End Sub
    Function GetCond(ByVal OpCode As Long, ByVal i As Integer, ByVal mode As Integer) As String
        Dim t As Integer
        Dim BL(50), rand, isAllied, MoreLess, abType, btWhen, btTarget, btBuffType, btHasBuff As Byte
        Dim ThisSplit(200), iChar, sTargetType, sBuffType, sHasBuff As String
        Dim iVarNo, iValue, btOp, tmpOpcode, iDist, iSeconds As Long
        Dim iDamage, iDif1, iDif2, iCount, iBuffer, iPlanet As Integer
        Dim cond As String
        Dim ulTime, ulEndTime As Long
        Dim ThisDate, hour1, hour2, min1, min2 As Long

        If mode = 0 Then
            'CondOpcodeList.Items.Add(OpCode)
            'BL = Blocks(BlockIndex).Records(RecordIndex).Conditions(i).Bytes 
            'should not do this. It makes BL a pseudonym for the main data.
            For t = 0 To 50 'instead we should copy it bytewise
                BL(t) = Blocks(BlockIndex).Records(RecordIndex).Conditions(i).Bytes(t)
            Next
        Else
            BL = TempCondBytes
        End If

        GetCond = "No definition available for opcode " + CStr(OpCode)
        tmpOpcode = OpCode - 67108865  'should convert the scale into 0 through 30 or so
        Select Case tmpOpcode
            Case 0
                GetCond = "Hold or Attack (always false) "
            Case 1
                iDamage = FindVal(BL(3), BL(2), BL(1), BL(0), 2)
                MoreLess = FindVal(BL(4), 0, 0, 0, 1)
                If MoreLess = 0 Then cond = " > " Else cond = " < "
                GetCond = "Check Damage counter: True if I have taken" + cond + CStr(iDamage)
            Case 2
                iDist = FindVal(BL(3), BL(2), BL(1), BL(0), 4)
                isAllied = FindVal(BL(4), 0, 0, 0, 1)
                If isAllied = 0 Then ichar = "players " Else ichar = "monsters "
                iDif1 = FindVal(BL(7), BL(6), 0, 0, 2)
                iDif2 = FindVal(BL(9), BL(8), 0, 0, 2)
                iCount = FindVal(BL(11), BL(10), 0, 0, 2)
                GetCond = "Check for " + iChar + " within distance " + CStr(iDist) + " of me with level range " + CStr(iDif1) + " to " + CStr(iDif2) + ". TRUE if >= " + CStr(iCount)
            Case 3
                iDist = FindVal(BL(3), BL(2), BL(1), BL(0), 4)
                GetCond = "Check distance from my spawn point. True if > " + CStr(iDist)
            Case 4
                iDist = FindVal(BL(3), BL(2), BL(1), BL(0), 4)
                MoreLess = FindVal(BL(4), 0, 0, 0, 1)
                If MoreLess = 0 Then cond = " > " Else cond = " < "
                GetCond = "Check distance to my target. TRUE if" + cond + CStr(iDist)
            Case 5
                abType = FindVal(BL(0), 0, 0, 0, 1)
                iValue = FindVal(BL(7), BL(6), BL(5), BL(4), 4)
                MoreLess = FindVal(BL(8), 0, 0, 0, 1)
                If MoreLess = 0 Then cond = " > " Else cond = " < "
                GetCond = "Check my " + GetABoption(abType) + " TRUE if" + cond + CStr(iValue)
            Case 6
                iValue = FindVal(BL(3), BL(2), BL(1), BL(0), 4)
                MoreLess = FindVal(BL(4), 0, 0, 0, 1)
                If MoreLess = 0 Then cond = " > " Else cond = " < "
                GetCond = "Check my HP. TRUE if" + cond + CStr(iValue)
            Case 7
                rand = FindVal(BL(0), 0, 0, 0, 1)
                GetCond = "Random Chance: " + CStr(rand) + " % "
            Case 8
                iDist = FindVal(BL(3), BL(2), BL(1), BL(0), 4)
                iDif1 = FindVal(BL(5), BL(4), 0, 0, 2)
                iDif2 = FindVal(BL(7), BL(6), 0, 0, 2)
                isAllied = FindVal(BL(8), 0, 0, 0, 1)
                If isAllied = 0 Then iChar = "players " Else iChar = "monsters "
                GetCond = "Check for " + iChar + " within distance " + CStr(iDist) + " of me with level range " + CStr(iDif1) + " to " + CStr(iDif2) + ". TRUE if more than 1 found"
            Case 9      'no bytes
                GetCond = "Check Targets. TRUE if my Attacker is NOT my Target"
            Case 10
                abType = FindVal(BL(0), 0, 0, 0, 1)
                MoreLess = FindVal(BL(1), 0, 0, 0, 1)
                If MoreLess = 0 Then cond = " > " Else cond = " < "
                GetCond = "Check Abilitys. TRUE if my Attacker's" + GetABoption(abType) + " " + cond + " that of my target"
            Case 11
                abType = FindVal(BL(0), 0, 0, 0, 1)
                iValue = FindVal(BL(7), BL(6), BL(5), BL(4), 4)
                MoreLess = FindVal(BL(8), 0, 0, 0, 1)
                If MoreLess = 0 Then cond = " > " Else cond = " < "
                GetCond = "Check Ability. TRUE if my Attacker's" + GetABoption(abType) + " " + cond + CStr(iValue)
            Case 12
                btWhen = FindVal(BL(0), 0, 0, 0, 1)
                If btWhen = 0 Then cond = " Day " Else cond = " Night "
                GetCond = "Check Day or Night. TRUE if it is currently" + cond
            Case 13
                btTarget = FindVal(BL(0), 0, 0, 0, 1)
                If btTarget = 0 Then sTargetType = " myself " Else sTargetType = " my target "
                btBuffType = FindVal(BL(1), 0, 0, 0, 1)
                If btBuffType = 0 Then sBuffType = " de-buffs " Else sBuffType = " buffs "
                btHasBuff = FindVal(BL(2), 0, 0, 0, 1)
                If btHasBuff = 0 Then sHasBuff = " are NOT present " Else sHasBuff = " are present "
                GetCond = "Check " + sTargetType + " for buffs. TRUE if" + sBuffType + sHasBuff
                t = t
            Case 14
                iVarNo = FindVal(BL(0), 0, 0, 0, 1)
                iBuffer = FindVal(BL(3), BL(2), 0, 0, 2)
                iValue = FindVal(BL(7), BL(6), BL(5), BL(4), 4)
                btOp = FindVal(BL(8), 0, 0, 0, 1)
                GetCond = "Check ObjVar [ " + CStr(RefVar) + " ][ " + CStr(iVarNo) + " ] TRUE if value" + GetbtOp(btOp) + CStr(iValue)
            Case 15
                iVarNo = FindVal(BL(0), 0, 0, 0, 1)
                iPlanet = FindVal(BL(3), BL(2), 0, 0, 2)
                iValue = FindVal(BL(7), BL(6), BL(5), BL(4), 4)
                btOp = FindVal(BL(8), 0, 0, 0, 1)
                GetCond = "Check World Variable [ " + getWorld(iPlanet) + " ][ " + CStr(iVarNo) + " ] TRUE if value" + GetbtOp(btOp) + CStr(iValue)
            Case 16
                iVarNo = FindVal(BL(0), 0, 0, 0, 1)
                iPlanet = FindVal(BL(3), BL(2), 0, 0, 2)
                iValue = FindVal(BL(7), BL(6), BL(5), BL(4), 4)
                btOp = FindVal(BL(8), 0, 0, 0, 1)
                GetCond = "Check Economy Variable [ " + getWorld(iPlanet) + " ][ " + CStr(iVarNo) + " ] TRUE if value" + GetbtOp(btOp) + CStr(iValue)
            Case 17
                iValue = FindVal(BL(3), BL(2), BL(1), BL(0), 4)
                RefVar = iValue
                GetCond = "Set Refvar equal to " + CStr(iValue)
            Case 18
                iDist = FindVal(BL(3), BL(2), BL(1), BL(0), 4)
                btOp = FindVal(BL(4), 0, 0, 0, 1)
                GetCond = "Check Distance to my owner. TRUE if " + GetbtOp(btOp) + CStr(iDist)
            Case 19
                ulTime = FindVal(BL(3), BL(2), BL(1), BL(0), 4)
                ulEndTime = FindVal(BL(7), BL(6), BL(5), BL(4), 4)
                GetCond = "Check Zone Time. TRUE if time is between " + CStr(ulTime) + " and " + CStr(ulEndTime)
            Case 20
                abType = FindVal(BL(0), 0, 0, 0, 1)
                iValue = FindVal(BL(7), BL(6), BL(5), BL(4), 4)
                btOp = FindVal(BL(8), 0, 0, 0, 1)
                cond = GetbtOp(btOp)
                GetCond = "Check my " + GetABoption(abType) + " TRUE if" + cond + CStr(iValue)
            Case 21
                GetCond = "Do I have an Owner?"
            Case 22
                GetCond = "Does my Owner have a target?"
            Case 23
                ulTime = FindVal(BL(3), BL(2), BL(1), BL(0), 4)
                ulEndTime = FindVal(BL(7), BL(6), BL(5), BL(4), 4)
                GetCond = "Check Map Time. TRUE if time is between " + CStr(ulTime) + " and " + CStr(ulEndTime)
            Case 24
                ThisDate = FindVal(BL(0), 0, 0, 0, 1)
                hour1 = FindVal(BL(1), 0, 0, 0, 1)
                min1 = FindVal(BL(2), 0, 0, 0, 1)
                hour2 = FindVal(BL(3), 0, 0, 0, 1)
                min2 = FindVal(BL(4), 0, 0, 0, 1)
                GetCond = "Check Date and Time. TRUE if date = " + CStr(ThisDate) + " and time is between " + CStr(hour1) + ":" + CStr(min1) + " and " + CStr(hour2) + ":" + CStr(min2)
            Case 25
                ThisDate = FindVal(BL(1), 0, 0, 0, 1)
                hour1 = FindVal(BL(2), 0, 0, 0, 1)
                min1 = FindVal(BL(3), 0, 0, 0, 1)
                hour2 = FindVal(BL(4), 0, 0, 0, 1)
                min2 = FindVal(BL(5), 0, 0, 0, 1)
                GetCond = "Check Day and time. TRUE if day = " + getDay(ThisDate) + " and time is between " + CStr(hour1) + ":" + CStr(min1) + " and " + CStr(hour2) + ":" + CStr(min2)
            Case 26
                iDif1 = FindVal(BL(1), BL(0), 0, 0, 2)
                iDif2 = FindVal(BL(3), BL(2), 0, 0, 3)
                GetCond = "Check Server Channel. TRUE if channel number is between " + CStr(iDif1) + " and " + CStr(iDif2)
            Case 27
                iDist = FindVal(BL(3), BL(2), BL(1), BL(0), 4)
                isAllied = FindVal(BL(4), 0, 0, 0, 1)
                iDif1 = FindVal(BL(7), BL(6), 0, 0, 2)
                iDif2 = FindVal(BL(9), BL(8), 0, 0, 2)
                iCount = FindVal(BL(11), BL(10), 0, 0, 2)
                btOp = FindVal(BL(12), 0, 0, 0, 1)
                If isAllied = 0 Then iChar = "players " Else iChar = "monsters "
                GetCond = "Check for " + iChar + " within distance " + CStr(iDist) + " of me with level range " + CStr(iDif1) + " to " + CStr(iDif2) + ". TRUE if" + GetbtOp(btOp) + CStr(iCount) + " are found"
            Case 28
                iVarNo = FindVal(BL(1), BL(0), 0, 0, 2)
                iValue = FindVal(BL(7), BL(6), BL(5), BL(4), 4)
                btOp = FindVal(BL(8), 0, 0, 0, 1)
                GetCond = "Check AI Variable [ " + CStr(iVarNo) + " ]. TRUE if " + GetbtOp(btOp) + CStr(iValue)
            Case 29
                GetCond = "Unknown. Not coded"
            Case 30
                iseconds = FindVal(BL(3), BL(2), BL(1), BL(0), 4)
                GetCond = "Check time since my spawn. TRUE if greater than " + CStr(iSeconds) + " Seconds "
        End Select
        GetCond = "OpCode " + CStr(tmpOpcode) + ":   " + GetCond 'add opcode number to the text
    End Function
    Function GetAction(ByVal OpCode As Long, ByVal i As Integer, ByVal mode As Integer) As String
        Dim BL(50), btOp, rwdType, eqType, btWho, msgType, thisByte, sOption, abOption, btMoreLess, btOwner, btTarget As Byte
        Dim t, Zone, reps, sp, sval, shNameLen, nVarNo, flag, Hash, iSec, item0, item1, item2, item3, item4, nMotion As Integer
        Dim ThisSplit(200) As String
        Dim QuestId, ItemId, dupCnt, PartyOpt, dataCnt, iVarNo, iVarType, iValue, itemsn, percenthp, percentmp As Long
        Dim thisX, thisY, monId, iRange, iTeam, ltbVal, skillNo, stringId, tmpOpcode, iDist As Long
        Dim Action, rwd, tempName, ltbString, skillType, owned As String

        If mode = 0 Then
            'ActionOpCodeList.Items.Add(OpCode - 16777216)
            'BL = Blocks(BlockIndex).Records(RecordIndex).Actions(i).Bytes
            For t = 0 To 50
                BL(t) = Blocks(BlockIndex).Records(RecordIndex).Actions(i).Bytes(t)
            Next
        Else
            BL = TempActionBytes
        End If

        GetAction = "No definition available for opcode " + CStr(OpCode)
        tmpOpcode = OpCode - 184549377
        Select Case tmpOpcode
            Case 0
                GetAction = "Stop all actions "
            Case 1
                thisByte = FindVal(BL(0), 0, 0, 0, 1)
                GetAction = "Set Emotion. " + CStr(thisByte)
            Case 2
                ltbString = FindVal(BL(3), BL(2), BL(1), BL(0), 4)
                GetAction = "Say LTB String" + +CStr(ltbString)
            Case 3
                idist = FindVal(BL(3), BL(2), BL(1), BL(0), 4)
                thisByte = FindVal(BL(4), 0, 0, 0, 1)
                GetAction = GetStance(thisByte) + " to a random location within distance " + CStr(iDist) + " of my present location"
            Case 4
                idist = FindVal(BL(3), BL(2), BL(1), BL(0), 4)
                thisByte = FindVal(BL(4), 0, 0, 0, 1)
                GetAction = GetStance(thisByte) + " to a random location within distance " + CStr(iDist) + " of my original spawn location"
            Case 5
                thisByte = FindVal(BL(0), 0, 0, 0, 1)
                GetAction = GetStance(thisByte) + " to a random location within a distance of 2 of selected Character (findChar)"
            Case 6
                iDist = FindVal(BL(3), BL(2), BL(1), BL(0), 4)
                abOption = FindVal(BL(4), 0, 0, 0, 1)
                btMoreLess = FindVal(BL(5), 0, 0, 0, 1)
                GetAction = "Start attack against enemy with" + GetHighLow(btMoreLess) + GetABoption(abOption) + "within a distance of " + CStr(iDist)
            Case 7
                GetAction = "Special attack"
            Case 8 'come back to this one later. There is something very wrong with it
                iDist = FindVal(BL(3), BL(2), BL(1), BL(0), 4)
                thisByte = FindVal(BL(4), 0, 0, 0, 1)
                GetAction = GetStance(thisByte) + " towards my target. Stop" + CStr(iDist) + "% Away from Target"
            Case 9
                monId = FindVal(BL(1), BL(0), 0, 0, 2)
                GetAction = "Convert to other monster with ID " + monId
            Case 10
                monId = FindVal(BL(1), BL(0), 0, 0, 2)
                GetAction = "Spawn monster with ID " + CStr(monId) + " at current location"
            Case 11
                iDist = FindVal(BL(3), BL(2), BL(1), BL(0), 4)
                iValue = FindVal(BL(7), BL(6), BL(5), BL(4), 4)     'number of monsters
                GetAction = "Force " + CStr(iValue) + " monsters of my own type within range " + CStr(iDist) + " to attack my target"
            Case 12
                GetAction = "Initiate combat with nearest enemy from list"
            Case 13
                GetAction = "Initiate combat with random enemy from list"
            Case 14
                iDist = FindVal(BL(3), BL(2), BL(1), BL(0), 4)
                GetAction = "Call on all monsters within range " + CStr(iDist) + " to attack my target"
            Case 15
                GetAction = "Retaliate. Start attack against the character that hit me."
            Case 16
                iDist = FindVal(BL(3), BL(2), BL(1), BL(0), 4)
                GetAction = "Run away for a distance of " + CStr(iDist)
            Case 17
                item0 = FindVal(BL(1), BL(0), 0, 0, 2)
                item1 = FindVal(BL(3), BL(2), 0, 0, 2)
                item2 = FindVal(BL(5), BL(4), 0, 0, 2)
                item3 = FindVal(BL(7), BL(6), 0, 0, 2)
                item4 = FindVal(BL(9), BL(8), 0, 0, 2)
                btOwner = FindVal(BL(12), 0, 0, 0, 1)
                If btOwner = 0 Then Action = " with no owner " Else Action = " owned by the player who hit me first"
                GetAction = "Drop one of these items " + CStr(item0) + ", " + CStr(item1) + ", " + CStr(item2) + ", " + CStr(item3) + ", " + CStr(item4) + "," + Action
            Case 18
                monId = FindVal(BL(1), BL(0), 0, 0, 2)
                iValue = FindVal(BL(3), BL(2), 0, 0, 2) 'number of monsters
                iDist = FindVal(BL(7), BL(6), BL(5), BL(4), 4)
                GetAction = "Force " + CStr(iValue) + " monsters with id " + CStr(monId) + " within range " + CStr(iDist) + " to attack my target"
            Case 19
                GetAction = "Initiate combat with nearest enemy from list"
            Case 20
                monId = FindVal(BL(1), BL(0), 0, 0, 2)
                btOp = FindVal(BL(2), 0, 0, 0, 1)
                iDist = FindVal(BL(7), BL(6), BL(5), BL(4), 4)
                GetAction = "Spawn monster with ID " + CStr(monId) + " within range " + CStr(iDist) + " of " + GetbtPos(btOp)
            Case 21
                GetAction = "Unused"
            Case 22
                GetAction = "Unused"
            Case 23
                GetAction = "Commit suicide"
            Case 24
                btTarget = FindVal(BL(0), 0, 0, 0, 1)
                sval = FindVal(BL(3), BL(2), 0, 0, 2)
                nMotion = FindVal(BL(5), BL(4), 0, 0, 2)
                GetAction = "use skill " + CStr(sval) + GetbtTarget(btTarget) + GetnMotion(nMotion)
            Case 25
                iVarNo = FindVal(BL(3), BL(2), BL(1), BL(0), 4)
                iValue = FindVal(BL(7), BL(6), BL(5), BL(4), 4)
                btOp = FindVal(BL(8), 0, 0, 0, 1)
                GetAction = "Set Object Variable [" + RefVar + "][" + CStr(iVarNo) + "] " + GetbtOp(btOp) + CStr(iValue)
            Case 26
                iVarNo = FindVal(BL(3), BL(2), BL(1), BL(0), 4)
                iValue = FindVal(BL(7), BL(6), BL(5), BL(4), 4)
                btOp = FindVal(BL(8), 0, 0, 0, 1)
                GetAction = "Set World Variable [" + CStr(iVarNo) + "] " + GetbtOp(btOp) + CStr(iValue)
            Case 27
                iVarNo = FindVal(BL(3), BL(2), BL(1), BL(0), 4)
                iValue = FindVal(BL(7), BL(6), BL(5), BL(4), 4)
                btOp = FindVal(BL(8), 0, 0, 0, 1)
                GetAction = "Set Economy Variable [" + CStr(iVarNo) + "] " + GetbtOp(btOp) + CStr(iValue)
            Case 28
                btOp = FindVal(BL(0), 0, 0, 0, 1)
                stringId = FindVal(BL(7), BL(6), BL(5), BL(4), 4)
                GetAction = GetMsgType(btOp) + "LTB string " + CStr(stringId)
            Case 29
                GetAction = "Run towards my owner for 80% of the distance"
            Case 30
                shNameLen = FindVal(BL(1), BL(0), 0, 0, 2)
                tempName = ""
                For t = 2 To shNameLen
                    tempName = tempName + Chr(FindVal(BL(t), 0, 0, 0, 1))
                Next
                GetAction = "Execute Quest Trigger " + tempName
            Case 31
                GetAction = "Attack my owner's target"
            Case 32
                Zone = FindVal(BL(1), BL(0), 0, 0, 2)
                btOp = FindVal(BL(2), 0, 0, 0, 1)
                GetAction = "Set PK flag for zone " + CStr(Zone) + " to" + GetOnOff(btOp)
            Case 33
                Zone = FindVal(BL(1), BL(0), 0, 0, 2)
                btOp = FindVal(BL(2), 0, 0, 0, 1)
                GetAction = "Set Regen mode for zone " + CStr(Zone) + " to" + GetOnOff(btOp)
            Case 34
                item0 = FindVal(BL(1), BL(0), 0, 0, 2)
                sval = FindVal(BL(3), BL(2), 0, 0, 2)
                GetAction = "Give " + CStr(sval) + " items with id " + CStr(item0) + " to my owner"
            Case 35
                iVarNo = FindVal(BL(1), BL(0), 0, 0, 2)
                iValue = FindVal(BL(7), BL(6), BL(5), BL(4), 4)
                btOp = FindVal(BL(8), 0, 0, 0, 1)
                GetAction = "Set AI variable [" + CStr(iVarNo) + "]" + GetbtOp(btOp) + " " + CStr(iValue)
            Case 36
                monId = FindVal(BL(1), BL(0), 0, 0, 2)
                btOwner = FindVal(BL(2), 0, 0, 0, 1)
                GetAction = "Spawn a monster with id " + CStr(monId) + " at my location " + GetPet(btOwner)
            Case 37
                monId = FindVal(BL(1), BL(0), 0, 0, 2)
                btOp = FindVal(BL(2), 0, 0, 0, 1)
                iDist = FindVal(BL(7), BL(6), BL(5), BL(4), 4)
                btOwner = FindVal(BL(8), BL(0), 0, 0, 2)
                GetAction = "Spawn 1 monster with ID " + CStr(monId) + "within distance " + CStr(iDist) + " of " + GetbtPos(btOp) + " " + GetPet(btOwner)
        End Select
        GetAction = "OpCode " + CStr(tmpOpcode) + ":   " + GetAction
        t = t
    End Function
    Private Sub ListBox4_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CondList.SelectedIndexChanged
        Dim t As Integer
        CondIndex = CondList.SelectedIndex + 1
        OpMode = 1
        CurrentCondOpcode.Text = Blocks(BlockIndex).Records(RecordIndex).Conditions(CondIndex).Command
        TempCondByteCount = Blocks(BlockIndex).Records(RecordIndex).Conditions(CondIndex).Length - 9
        For t = 0 To 50
            TempCondBytes(t) = Blocks(BlockIndex).Records(RecordIndex).Conditions(CondIndex).Bytes(t)
        Next
        DispCondData()
        DisplayCurrentCondBytes()
    End Sub
    Private Sub ListBox6_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ActionList.SelectedIndexChanged
        Dim t As Integer
        ActionIndex = ActionList.SelectedIndex + 1
        OpMode = 1
        CurrentActionOpcode.Text = Blocks(BlockIndex).Records(RecordIndex).Actions(ActionIndex).Command
        TempActionByteCount = Blocks(BlockIndex).Records(RecordIndex).Actions(ActionIndex).Length - 9
        For t = 0 To 50
            TempActionBytes(t) = Blocks(BlockIndex).Records(RecordIndex).Actions(ActionIndex).Bytes(t)
        Next
        DispActionData()
        DisplayCurrentActionBytes()
    End Sub
    Private Sub LoadtempCondBytes(ListBytes As String)
        Dim t As Integer
        Dim SplitList As String()

        SplitList = Split(ListBytes, " ", -1)
        'clear CurrentCondBytes
        For t = 0 To UBound(TempCondBytes)
            TempCondBytes(t) = 0
        Next
        TempCondByteCount = UBound(SplitList)
        If ListBytes <> "" Then
            For t = 0 To UBound(SplitList)
                TempCondBytes(t) = SplitList(t)
            Next
        End If
        DisplayCurrentcondBytes()
    End Sub
    Private Sub LoadtempActionBytes(ListBytes As String)
        Dim t As Integer
        Dim SplitList As String()

        SplitList = Split(ListBytes, " ", -1)
        'clear CurrentActionBytes
        For t = 0 To UBound(TempActionBytes)
            TempActionBytes(t) = 0
        Next
        TempActionByteCount = UBound(SplitList)
        If ListBytes <> "" Then
            For t = 0 To UBound(SplitList)
                TempActionBytes(t) = SplitList(t)
            Next
        End If
        DisplayCurrentActionBytes()
    End Sub
    Private Sub DisplayCurrentActionBytes()
        Dim t As Integer
        Dim TempByteString As String
        TempByteString = ""
        If RadioButton1.Checked = True Then
            For t = 0 To TempActionByteCount
                If t = 0 Then
                    TempByteString += Hex(TempActionBytes(t))
                Else
                    TempByteString += " " + Hex(TempActionBytes(t))
                End If
            Next t
        Else
            For t = 0 To TempActionByteCount
                If t = 0 Then
                    TempByteString += CStr(TempActionBytes(t))
                Else
                    TempByteString += " " + CStr(TempActionBytes(t))
                End If
            Next t
        End If
        t = t
        CurrentActionByteString.Text = TempByteString
    End Sub
    Private Sub DisplayCurrentCondBytes()
        Dim t As Integer
        Dim TempByteString As String
        TempByteString = ""
        If RadioButton1.Checked = True Then
            For t = 0 To TempCondByteCount
                If t = 0 Then
                    TempByteString += Hex(TempCondBytes(t))
                Else
                    TempByteString += " " + Hex(TempCondBytes(t))
                End If
            Next t
        Else
            For t = 0 To TempCondByteCount
                If t = 0 Then
                    TempByteString += CStr(TempCondBytes(t))
                Else
                    TempByteString += " " + CStr(TempCondBytes(t))
                End If
            Next t
        End If
        t = t
        CurrentCondByteString.Text = TempByteString
    End Sub
    Function FindVal(ByVal a As Byte, ByVal b As Byte, ByVal c As Byte, ByVal d As Byte, ByVal e As Byte) As Long
        Dim hexi As String
        Dim hexi1 As String
        Dim hexi2 As String
        Dim hexi3 As String
        Dim hexi4 As String
        Dim testval As Long
        Select Case e
            Case 1
                FindVal = CLng(a)
                'Case 2
                '    hexi = "&H" + CStr(Hex(a)) + CStr(Hex(b))
                '    FindVal = Val(hexi)
                'Case 4
                '    hexi = "&H" + CStr(Hex(a)) + CStr(Hex(b)) + CStr(Hex(c)) + CStr(Hex(d))
                '    FindVal = Val(hexi)
            Case 2
                hexi1 = CStr(Hex(a))
                If Len(hexi1) = 1 Then hexi1 = "0" + hexi1
                hexi2 = CStr(Hex(b))
                If Len(hexi2) = 1 Then hexi2 = "0" + hexi2
                hexi = "&H" + hexi1 + hexi2
                FindVal = Val(hexi)
                a = a
            Case 4
                hexi1 = CStr(Hex(a))
                If Len(hexi1) = 1 Then hexi1 = "0" + hexi1
                hexi2 = CStr(Hex(b))
                If Len(hexi2) = 1 Then hexi2 = "0" + hexi2
                hexi3 = CStr(Hex(c))
                If Len(hexi3) = 1 Then hexi3 = "0" + hexi3
                hexi4 = CStr(Hex(d))
                If Len(hexi4) = 1 Then hexi4 = "0" + hexi4
                hexi = "&H" + hexi1 + hexi2 + hexi3 + hexi4
                FindVal = Val(hexi)
                testval = a * 4096 + b * 256 + c * 16 + d
                If testval <> FindVal Then
                    a = a
                End If
        End Select
        a = a
    End Function
    Function GetDayNight(ByVal val) As String
        If val = 0 Then
            GetDayNight = "Day"
        Else
            GetDayNight = "Night"
        End If
    End Function
    Function GetCheckTarget(ByVal val) As String
        If val = 0 Then
            GetCheckTarget = "Myself"
        Else
            GetCheckTarget = "My Target"
        End If
    End Function
    Function GetStatusType(ByVal val) As String
        GetStatusType = "INVALID"
        Select Case val
            Case 0
                GetStatusType = "DeBuffs"
            Case 1
                GetStatusType = "Buffs"
            Case 2
                GetStatusType = "Damage Over Time"
        End Select
    End Function
    Function GetHave(ByVal val) As String
        If val = 0 Then
            GetHave = "NOT present"
        Else
            GetHave = "PRESENT"
        End If
    End Function
    Function GetDay(val As Integer) As String
        GetDay = " Sunday "
        Select Case val
            Case 0
                val = " Sunday "
            Case 1
                val = " Monday "
            Case 2
                val = " Tuesday "
            Case 3
                val = " Wednesday "
            Case 4
                val = " Thursday "
            Case 5
                val = " Friday "
            Case 6
                val = " Saturday "
        End Select
    End Function
    Function GetWorld(val As Integer) As String
        val = " Junon "
        Select Case val
            Case 0
                val = " Junon "
            Case 1
                val = " Luna "
            Case 2
                val = " Eldeon "
            Case 3
                val = " Oro "
        End Select
    End Function
    Function GetbtOp(ByVal btOp) As String
        GetbtOp = ""
        Select Case btOp
            Case 0
                GetbtOp = " = "
            Case 1
                GetbtOp = " > "
            Case 2
                GetbtOp = " >= "
            Case 3
                GetbtOp = " < "
            Case 4
                GetbtOp = " <= "
            Case 5
                GetbtOp = " Set value to "
            Case 6
                GetbtOp = " Add value "
            Case 7
                GetbtOp = " Subtract value "
            Case 8
                GetbtOp = " UnDefined "
            Case 9
                GetbtOp = " Increment "
            Case 10
                GetbtOp = " != "
        End Select
    End Function
    Function GetABoption(ByVal ref) As String
        GetABoption = " Un-Defined "
        Select Case ref
            Case 0
                GetABoption = " Level "
            Case 1
                GetABoption = " Attack Power "
            Case 2
                GetABoption = " Defense "
            Case 3
                GetABoption = " Magic Defense "
            Case 4
                GetABoption = " HP "
            Case 5
                GetABoption = " Charm "
        End Select
    End Function
    Function GetSoption(ByVal ref) As String
        GetSoption = " Un-Defined "
        Select Case ref
            Case 2
                GetSoption = " Gender "
            Case 3
                GetSoption = " Birthstone "
            Case 4
                GetSoption = " Job "
            Case 5
                GetSoption = " Union "
            Case 6
                GetSoption = " Ranking "
            Case 7
                GetSoption = " Reputation "
            Case 10
                GetSoption = " Strength "
            Case 11
                GetSoption = " Dexterity "
            Case 12
                GetSoption = " Inteligence "
            Case 13
                GetSoption = " Concentration "
            Case 14
                GetSoption = " Charm "
            Case 15
                GetSoption = " Sense "
            Case 30
                GetSoption = " Experience Rate "
            Case 31
                GetSoption = " Level "
            Case 32
                GetSoption = " Stat points "
            Case 40
                GetSoption = " Money "
            Case 81
                GetSoption = " Junon order Union points "
            Case 82
                GetSoption = " Union 2 points "
            Case 83
                GetSoption = " Righteous Crusaders Union points "
            Case 84
                GetSoption = " Union 4 points "
            Case 85
                GetSoption = " Ferrel Guild Union points "
            Case 86
                GetSoption = " Union 6 points "
            Case 87
                GetSoption = " Union 7 points "
            Case 88
                GetSoption = " Union 8 points "
            Case 89
                GetSoption = " Union 9 points "
            Case 90
                GetSoption = " Kuro-Tejina Union points "
            Case Else
                GetSoption = CStr(ref) + " is Undefined"

        End Select
    End Function
    Function GetVarType(ByVal nVarType As Integer) As String
        GetVarType = "undefined" + CStr(nVarType)
        Dim a As Integer
        a = a
        Select Case nVarType
            Case 0
                GetVarType = "ActiveQuest"
            Case 16
                GetVarType = "SwitchBit"
            Case 32
                GetVarType = "Remaining Time"
            Case 48
                GetVarType = "EpisodeVar"
            Case 64
                GetVarType = "JobVar"
            Case 80
                GetVarType = "PlanetVar"
            Case 96
                GetVarType = "UnionVar"
        End Select
    End Function
    Function GetMap(ByVal zone As Integer) As String
        GetMap = "Invalid Map"
        Select Case zone
            Case 1
                GetMap = "Canyon City of Zant"
            Case 2
                GetMap = "City of Junon Polis"
            Case 3
                GetMap = "Dolphin Island"
            Case 4
                GetMap = "Title Map"
            Case 5
                GetMap = "Junon Cartel"
            Case 6
                GetMap = "Crusader Training Camp"
            Case 7
                GetMap = "(NULL)Arena - III"
            Case 8
                GetMap = "Lion's Plains"
            Case 9
                GetMap = "Junon Cartel"
            Case 11
                GetMap = "Junon Clan Field"
            Case 12
                GetMap = "Junon Clan Field"
            Case 13
                GetMap = "Junon Clan Field"
            Case 15
                GetMap = "Lion's Den"
            Case 16
                GetMap = "House of the Holy"
            Case 17
                GetMap = "The Vault"
            Case 18
                GetMap = "Mystic Shrine"
            Case 19
                GetMap = "Planet Warping Scene"
            Case 21
                GetMap = "Valley of Luxem Tower"
            Case 22
                GetMap = "Adventurer's Plains"
            Case 23
                GetMap = "Breezy Hills"
            Case 24
                GetMap = "El Verloon Desert"
            Case 25
                GetMap = "Anima Lake"
            Case 26
                GetMap = "Forest of Wisdom"
            Case 27
                GetMap = "Kenji Beach"
            Case 28
                GetMap = "Gorge of Silence"
            Case 29
                GetMap = "Desert of the Dead"
            Case 31
                GetMap = "Goblin Cave (B1)"
            Case 32
                GetMap = "Goblin Cave (B2)"
            Case 33
                GetMap = "Goblin Cave (B3)"
            Case 34
                GetMap = "Cave of Ulverick (B1)"
            Case 35
                GetMap = "Cave of Ulverick (B2)"
            Case 37
                GetMap = "Sunshine Coast"
            Case 38
                GetMap = "Santa Planetoid"
            Case 40
                GetMap = "Grand Ballroom"
            Case 41
                GetMap = "Oblivion Temple Entrance"
            Case 42
                GetMap = "Oblivion Temple B2"
            Case 43
                GetMap = "Oblivion Temple B3"
            Case 44
                GetMap = "Oblivion Temple B4"
            Case 46
                GetMap = "Temple Campgrounds"
            Case 51
                GetMap = "Magic City of the Eucar"
            Case 52
                GetMap = "Mana Snowfields"
            Case 53
                GetMap = "Arumic Valley"
            Case 54
                GetMap = "Crystal Snowfields"
            Case 55
                GetMap = "Freezing Plateau"
            Case 56
                GetMap = "Forgotten Temple (B1)"
            Case 57
                GetMap = "Forgotten Temple (B2)"
            Case 58
                GetMap = "Mount Eruca"
            Case 59
                GetMap = "Luna Clan Field"
            Case 61
                GetMap = "Xita Refuge"
            Case 62
                GetMap = "Shady Jungle"
            Case 63
                GetMap = "Forest of Wandering"
            Case 64
                GetMap = "Marsh of Ghosts"
            Case 65
                GetMap = "Sikuku Underground Prison"
            Case 66
                GetMap = "Sikuku Ruins"
            Case 70
                GetMap = "Pedion(OLD)"
            Case 71
                GetMap = "Pedion(OLD)"
            Case 72
                GetMap = "Pedion(OLD)"
            Case 74
                GetMap = "Pedion"
            Case 80
                GetMap = "Oblivion Rooms (B1)"
            Case 81
                GetMap = "Oblivion Rooms (B2)"
            Case 82
                GetMap = "Oblivion Rooms (B3)"
            Case 83
                GetMap = "Oblivion Rooms (B4)"
        End Select
    End Function
    Function GetMob(ByVal monid As Integer) As String
        GetMob = CStr(monid)
    End Function
    Function GetLTB(ByVal ltbVal As Long) As String
        GetLTB = CStr(ltbVal)
    End Function
    Function GetHasSkill(val As Long) As String
        GetHasSkill = "Invalid btOp value"
        If val = 0 Then GetHasSkill = "Does NOT have either skill"
        If val = 1 Then GetHasSkill = "Has at least one of the skills"
    End Function
    Function GetNear(val As Integer) As String
        GetNear = "undefined"
        If val = 0 Then GetNear = "not within"
        If val = 1 Then GetNear = "within"
    End Function
    Function GetZeroTerminatedString(start As Integer, mode As Integer) As String
        'If mode = 0 then use cond else use action
        Dim tmp As String
        Dim ThisByte, t As Byte
        t = start - 1 : ThisByte = 255 : tmp = ""
        While ThisByte <> 0
            t += 1
            If mode = 0 Then
                ThisByte = TempCondBytes(t)
            Else
                ThisByte = TempActionBytes(t)
            End If
            If ThisByte <> 0 Then
                tmp += Chr(ThisByte)
            End If
        End While
        t = t
        GetZeroTerminatedString = tmp
    End Function

    Private Sub Button8_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button8.Click
        'put the current condition data into the record structure
        Dim OpCode, arraysize As Long
        Dim a, i, t As Integer
        Dim CondString, TempByteString, ThisSplit(200) As String
        CondString = ""
        a = a
        If CurrentCondOpcode.Text = "" Then Exit Sub
        'Set data block size
        a = a
        'copy data into memory

        Blocks(BlockIndex).Records(RecordIndex).Conditions(CondIndex).Command = CLng(CurrentCondOpcode.Text)
        TempByteString = CurrentCondByteString.Text
        ThisSplit = Split(TempByteString, " ", -1)
        arraysize = ThisSplit.GetUpperBound(0)
        Blocks(BlockIndex).Records(RecordIndex).Conditions(CondIndex).Length = arraysize + 9
        For t = 0 To 50
            Blocks(BlockIndex).Records(RecordIndex).Conditions(CondIndex).Bytes(t) = 0
        Next

        For t = 0 To 50
            If t <= arraysize Then
                Blocks(BlockIndex).Records(RecordIndex).Conditions(CondIndex).Bytes(t) = TempCondBytes(t)
            Else
                Blocks(BlockIndex).Records(RecordIndex).Conditions(CondIndex).Bytes(t) = 0
            End If
        Next
        
        'clear outputs
        CondList.Items.Clear()
        'display the records
        For i = 1 To Blocks(BlockIndex).Records(RecordIndex).Conditioncount
            OpCode = Blocks(BlockIndex).Records(RecordIndex).Conditions(i).Command
            CondList.Items.Add(GetCond(OpCode, i, 0))
        Next i
    End Sub

    Private Sub Button9_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AddCond.Click
        'Add the current condition data into the record structure as a new condition
        Dim OpCode, arraysize As Long
        Dim a, i, t As Integer
        Dim CondString, TempByteString, ThisSplit(200) As String
        CondString = ""
        a = a
        If CurrentCondOpcode.Text = "" Then Exit Sub
        'Set data block size
        a = a

        'add one more record to the index
        Blocks(BlockIndex).Records(RecordIndex).Conditioncount = Blocks(BlockIndex).Records(RecordIndex).Conditioncount + 1
        CondIndex = Blocks(BlockIndex).Records(RecordIndex).Conditioncount
        'copy data into memory

        Blocks(BlockIndex).Records(RecordIndex).Conditions(CondIndex).Command = CLng(CurrentCondOpcode.Text)
        TempByteString = CurrentCondByteString.Text
        ThisSplit = Split(TempByteString, " ", -1)
        arraysize = ThisSplit.GetUpperBound(0)
        Blocks(BlockIndex).Records(RecordIndex).Conditions(CondIndex).Length = arraysize + 9
        Blocks(BlockIndex).Records(RecordIndex).Conditions(CondIndex).Bytes = New Byte(50) {}
        a = a
        For t = 0 To 50
            Blocks(BlockIndex).Records(RecordIndex).Conditions(CondIndex).Bytes(t) = 0
        Next
        For t = 0 To 50
            If t <= arraysize Then
                Blocks(BlockIndex).Records(RecordIndex).Conditions(CondIndex).Bytes(t) = TempCondBytes(t)
            Else
                Blocks(BlockIndex).Records(RecordIndex).Conditions(CondIndex).Bytes(t) = 0
            End If
        Next
       
        'clear outputs
        CondList.Items.Clear()
        'display the records
        For i = 1 To Blocks(BlockIndex).Records(RecordIndex).Conditioncount
            OpCode = Blocks(BlockIndex).Records(RecordIndex).Conditions(i).Command
            CondList.Items.Add(GetCond(OpCode, i, 0))
        Next i
    End Sub

    Private Sub Button10_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button10.Click
        'delete condition
        Dim OpCode As Long
        Dim rusure, i, t As Integer
        rusure = MsgBox("Do you really want to delete the currently selected condition?", vbYesNo, "WARNING")
        If rusure = vbNo Then Exit Sub
        For t = CondIndex To Blocks(BlockIndex).Records(RecordIndex).Conditioncount - 1
            Blocks(BlockIndex).Records(RecordIndex).Conditions(t) = Blocks(BlockIndex).Records(RecordIndex).Conditions(t + 1)
        Next t
        Blocks(BlockIndex).Records(RecordIndex).Conditioncount = Blocks(BlockIndex).Records(RecordIndex).Conditioncount - 1
        'clear outputs
        CondList.Items.Clear()
        'display the records
        For i = 1 To Blocks(BlockIndex).Records(RecordIndex).Conditioncount
            OpCode = Blocks(BlockIndex).Records(RecordIndex).Conditions(i).Command
            'ListBox3.Items.Add(OpCode)
            CondList.Items.Add(GetCond(OpCode, i, 0))
        Next i
    End Sub

   

    Private Sub ReplaceAction_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ReplaceAction.Click
        'put the current action data into the record structure
        Dim OpCode, arraysize As Long
        Dim a, i, t As Integer
        Dim TempByteString, ThisSplit(200) As String
        If CurrentActionOpcode.Text = "" Then Exit Sub
        'Set data block size
        a = a
        'copy data into memory

        Blocks(BlockIndex).Records(RecordIndex).Actions(ActionIndex).Command = CLng(CurrentActionOpcode.Text)
        TempByteString = CurrentActionByteString.Text
        'Get the array size
        ThisSplit = Split(TempByteString, " ", -1)
        arraysize = UBound(ThisSplit)

        Blocks(BlockIndex).Records(RecordIndex).Actions(ActionIndex).Length = arraysize + 9
        'clear current action bytes
        For t = 0 To 50
            If t <= arraysize Then
                Blocks(BlockIndex).Records(RecordIndex).Actions(ActionIndex).Bytes(t) = TempActionBytes(t)
            Else
                Blocks(BlockIndex).Records(RecordIndex).Actions(ActionIndex).Bytes(t) = 0
            End If
        Next
        'clear outputs
        ActionList.Items.Clear()
        'display the records
        For i = 1 To Blocks(BlockIndex).Records(RecordIndex).Actioncount
            OpCode = Blocks(BlockIndex).Records(RecordIndex).Actions(i).Command
            ActionList.Items.Add(GetAction(OpCode, i, 0))
            a = a
        Next i
    End Sub

    Private Sub AddAction_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AddAction.Click
        'Add the current action data into the record structure as a new condition
        Dim OpCode, arraysize As Long
        Dim a, i, t As Integer
        Dim TempByteString, ThisSplit(200) As String 
        If CurrentActionOpcode.Text = "" Then Exit Sub
        'Set data block size
        a = a

        'add one more record to the index
        Blocks(BlockIndex).Records(RecordIndex).Actioncount = Blocks(BlockIndex).Records(RecordIndex).Actioncount + 1
        ActionIndex = Blocks(BlockIndex).Records(RecordIndex).Actioncount
        'copy data into memory
        Blocks(BlockIndex).Records(RecordIndex).Actions(ActionIndex).Command = CLng(CurrentActionOpcode.Text)
        TempByteString = CurrentActionByteString.Text

        'get the array size
        ThisSplit = Split(TempByteString, " ", -1)
        arraysize = UBound(ThisSplit)
        a = a
        Blocks(BlockIndex).Records(RecordIndex).Actions(ActionIndex).Length = arraysize + 9 'arraysize is 1 smaller than the actual size of the array ????
        Blocks(BlockIndex).Records(RecordIndex).Actions(ActionIndex).Bytes = New Byte(50) {}
        For t = 0 To 50
            If t <= arraysize Then
                Blocks(BlockIndex).Records(RecordIndex).Actions(ActionIndex).Bytes(t) = TempActionBytes(t)
            Else
                Blocks(BlockIndex).Records(RecordIndex).Actions(ActionIndex).Bytes(t) = 0
            End If
        Next
        'clear outputs
        ActionList.Items.Clear()
        'display the records
        For i = 1 To Blocks(BlockIndex).Records(RecordIndex).Actioncount
            OpCode = Blocks(BlockIndex).Records(RecordIndex).Actions(i).Command
            ActionList.Items.Add(GetAction(OpCode, i, 0))
            a = a
        Next i
    End Sub

    Private Sub DeleteAction_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DeleteAction.Click
        'Delete Action
        Dim OpCode As Long
        Dim rusure, i, t As Integer
        rusure = MsgBox("Do you really want to delete the currently selected condition?", vbYesNo, "WARNING")
        If rusure = vbNo Then Exit Sub
        For t = ActionIndex To Blocks(BlockIndex).Records(RecordIndex).Actioncount - 1
            Blocks(BlockIndex).Records(RecordIndex).Actions(t) = Blocks(BlockIndex).Records(RecordIndex).Actions(t + 1)
        Next t
        Blocks(BlockIndex).Records(RecordIndex).Actioncount = Blocks(BlockIndex).Records(RecordIndex).Actioncount - 1
        'clear outputs
        ActionList.Items.Clear()
        'display the records
        For i = 1 To Blocks(BlockIndex).Records(RecordIndex).Actioncount
            OpCode = Blocks(BlockIndex).Records(RecordIndex).Actions(i).Command
            'ListBox5.Items.Add(OpCode)
            ActionList.Items.Add(GetAction(OpCode, i, 0))
        Next i
    End Sub

    Private Sub TextBox8_MouseClick(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles CurrentCondOpcode.MouseClick
        OpMode = 1
        Opcodes.Show()
    End Sub

    Private Sub TextBox9_MouseClick(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles CurrentActionOpcode.MouseClick
        Dim a As Integer
        OpMode = 2
        a = a
        Opcodes.Show()
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        'add a new record
        Dim n As Integer
        If BlockIndex = 0 Then
            MsgBox("Please select a Block to add the record to")
        End If
        Blocks(BlockIndex).RecordCount = Blocks(BlockIndex).RecordCount + 1
        RecordIndex = Blocks(BlockIndex).RecordCount
        Blocks(BlockIndex).Records(RecordIndex).RecordNameBytes = New Byte(30) {}
        Blocks(BlockIndex).Records(RecordIndex).Conditions = New condition(50) {}
        Blocks(BlockIndex).Records(RecordIndex).Actions = New action(50) {}
        For n = 0 To 30
            Blocks(BlockIndex).Records(RecordIndex).RecordNameBytes(n) = 0
        Next n
        Blocks(BlockIndex).Records(RecordIndex).Conditioncount = 0
        Blocks(BlockIndex).Records(RecordIndex).Actioncount = 0
        Dim i As Integer
        ListBox2.Items.Clear()
        CondList.Items.Clear()
        ActionList.Items.Clear()
        For i = 1 To Blocks(BlockIndex).RecordCount
            ListBox2.Items.Add("Record " + CStr(i) + "   " + Blocks(BlockIndex).Records(i).Recordname)
        Next i
        BlockName.Text = Blocks(BlockIndex).BlockName
        TextBox11.Text = ""
    End Sub

    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
        Dim TempRecord As Record
        Dim opCode, i As Integer
        If RecordIndex = 1 Then
            MsgBox("Cannot move up. This is the first record")
            Exit Sub
        End If
        TempRecord = Blocks(BlockIndex).Records(RecordIndex - 1)
        Blocks(BlockIndex).Records(RecordIndex - 1) = Blocks(BlockIndex).Records(RecordIndex)
        Blocks(BlockIndex).Records(RecordIndex) = TempRecord
        CondList.Items.Clear()
        ActionList.Items.Clear()
        RefVar = "undefined"

        For i = 1 To Blocks(BlockIndex).Records(RecordIndex).Conditioncount
            OpCode = Blocks(BlockIndex).Records(RecordIndex).Conditions(i).Command
            CondList.Items.Add(GetCond(OpCode, i, 0))
        Next i

        For i = 1 To Blocks(BlockIndex).Records(RecordIndex).Actioncount
            OpCode = Blocks(BlockIndex).Records(RecordIndex).Actions(i).Command
            ActionList.Items.Add(GetAction(OpCode, i, 0))
        Next i
        TextBox11.Text = Blocks(BlockIndex).Records(RecordIndex).Recordname
    End Sub

    Private Sub Button5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button5.Click
        Dim TempRecord As Record
        Dim opCode, i As Integer
        If RecordIndex = Blocks(BlockIndex).RecordCount Then
            MsgBox("Cannot move down. This is the last record")
            Exit Sub
        End If
        TempRecord = Blocks(BlockIndex).Records(RecordIndex + 1)
        Blocks(BlockIndex).Records(RecordIndex + 1) = Blocks(BlockIndex).Records(RecordIndex)
        Blocks(BlockIndex).Records(RecordIndex) = TempRecord
        CondList.Items.Clear()
        ActionList.Items.Clear()
        RefVar = "undefined"
        For i = 1 To Blocks(BlockIndex).Records(RecordIndex).Conditioncount
            opCode = Blocks(BlockIndex).Records(RecordIndex).Conditions(i).Command
            CondList.Items.Add(GetCond(opCode, i, 0))
        Next i
        For i = 1 To Blocks(BlockIndex).Records(RecordIndex).Actioncount
            opCode = Blocks(BlockIndex).Records(RecordIndex).Actions(i).Command
            ActionList.Items.Add(GetAction(opCode, i, 0))
        Next i
        TextBox11.Text = Blocks(BlockIndex).Records(RecordIndex).Recordname
    End Sub

    Private Sub Button6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button6.Click
        Dim RUsure As String
        Dim t As Integer
        rusure = MsgBox("Do you really want to delete the currently selected record?", vbYesNo, "WARNING")
        If rusure = vbNo Then Exit Sub
        For t = RecordIndex To Blocks(BlockIndex).RecordCount - 1
            Blocks(BlockIndex).Records(t) = Blocks(BlockIndex).Records(t + 1)
        Next t
        Blocks(BlockIndex).RecordCount = Blocks(BlockIndex).RecordCount - 1
        Dim i As Integer
        ListBox2.Items.Clear()
        CondList.Items.Clear()
        ActionList.Items.Clear()
        For i = 1 To Blocks(BlockIndex).RecordCount
            ListBox2.Items.Add("Record " + CStr(i) + "   " + Blocks(BlockIndex).Records(i).Recordname)
        Next i
        BlockName.Text = Blocks(BlockIndex).BlockName
        TextBox11.Text = ""
    End Sub


    Private Sub TextBox9_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CurrentActionOpcode.TextChanged

    End Sub

    Private Sub Button15_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button15.Click
        Dim NewName As String
        Dim i, j As Integer
        Dim CanUseName As Boolean
        CanUseName = True
        NewName = TextBox11.Text
        For i = 1 To BlockCount
            For j = 1 To Blocks(i).RecordCount
                If Blocks(i).Records(j).Recordname = NewName Then
                    CanUseName = False
                End If
            Next
        Next
        If CanUseName = False Then
            MsgBox("Sorry. That name is already in use. please pick another")
            Exit Sub
        End If
        Blocks(BlockIndex).Records(RecordIndex).Recordname = NewName
        For i = 1 To Len(NewName)
            Blocks(BlockIndex).Records(RecordIndex).RecordNameBytes(i) = CByte(Asc(Mid(NewName, i, 1)))
        Next
        ListBox2.Items.Clear()
        For i = 1 To Blocks(BlockIndex).RecordCount
            ListBox2.Items.Add("Record " + CStr(i) + "   " + Blocks(BlockIndex).Records(i).Recordname)
        Next i
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        conddropdown.Items.Add("0  : Hold or attack (never used).")
        conddropdown.Items.Add("1  : Check damage done to me.")
        conddropdown.Items.Add("2  : Find Player/Monster (FindCHAR) within a specified range using X iterations.")
        conddropdown.Items.Add("3  : Check distance from origin (initial spawn point).")
        conddropdown.Items.Add("4  : Check Distance to my current target.")
        conddropdown.Items.Add("5  : Check my target's ability.")
        conddropdown.Items.Add("6  : Check my HP.")
        conddropdown.Items.Add("7  : Random chance percentage.")
        conddropdown.Items.Add("8  : Find first Player/Monster (FindCHAR) within a specified range.")
        conddropdown.Items.Add("9  : Check Target. TRUE if my Attacker is NOT my Target.")
        conddropdown.Items.Add("10 : Compare ability. My Attacker's and my Target's.")
        conddropdown.Items.Add("11 : Check my target's ability.")
        conddropdown.Items.Add("12 : Check if it is day or night")
        conddropdown.Items.Add("13 : Check myself/my target for buffs.")
        conddropdown.Items.Add("14 : Check NPC Variable.")
        conddropdown.Items.Add("15 : Check World Variable")
        conddropdown.Items.Add("16 : Check Economy Variable.")
        conddropdown.Items.Add("17 : Set NPC Variable.")
        conddropdown.Items.Add("18 : Check Distance to owner.")
        conddropdown.Items.Add("19 : Check Zone time (between start and end).")
        conddropdown.Items.Add("20 : Check My ability")
        conddropdown.Items.Add("21 : Am I have an orphaned summon?")
        conddropdown.Items.Add("22 : Does my owner have a target?")
        conddropdown.Items.Add("23 : Check World time (between start and end).")
        conddropdown.Items.Add("24 : Check Local Date & time (between start and end).")
        conddropdown.Items.Add("25 : Check Local Day & time (between start and end).")
        conddropdown.Items.Add("26 : Check Server Channel.")
        conddropdown.Items.Add("27 : Count Near Players/Monsters.")
        conddropdown.Items.Add("28 : Check target.")
        conddropdown.Items.Add("29 : Check my age (time since spawn).")

        actiondropdown.Items.Add("0 : Stop all actions")
        actiondropdown.Items.Add("1 : Set Emotion")
        actiondropdown.Items.Add("2 : Say LTB String")
        actiondropdown.Items.Add("3 : Run/Walk to a random position within X of Present position.")
        actiondropdown.Items.Add("4 : Run/Walk to a random position within X of Origin position.")
        actiondropdown.Items.Add("5 : Run/Walk to a random position within 2 of FindCHAR's position.")
        actiondropdown.Items.Add("6 : Run and attack enemy with the highest/lowest ability.")
        actiondropdown.Items.Add("7 : Do Special Attack.")
        actiondropdown.Items.Add("8 : Run/Walk towards Target for distance X.")
        actiondropdown.Items.Add("9 : Transform to new monster")
        actiondropdown.Items.Add("10 : Spawn a monster at my position")
        actiondropdown.Items.Add("11 : Call for reinforcements members of my team to attack my target")
        actiondropdown.Items.Add("12 : Run and attack closest Player")
        actiondropdown.Items.Add("13 : Run and attack FindCHAR.")
        actiondropdown.Items.Add("14 : Call for reinforcements from other monsters of my type to attack my target")
        actiondropdown.Items.Add("15 : Attack the character that just hit me (Retaliation).")
        actiondropdown.Items.Add("16 : Run away for distance X")
        actiondropdown.Items.Add("17 : Drop one of 5 items")
        actiondropdown.Items.Add("18 : Call for reinforcements. X monsters of type Y will attack my target")
        actiondropdown.Items.Add("19 : Run and attack closest Player. (Same as 12)")
        actiondropdown.Items.Add("20 : Spawn monster (varous positions possible)")
        actiondropdown.Items.Add("21 : Unused")
        actiondropdown.Items.Add("22 : Unused")
        actiondropdown.Items.Add("23 : Comit Suicide")
        actiondropdown.Items.Add("24 : Do a skill.")
        actiondropdown.Items.Add("25 : Set NPC Variable.")
        actiondropdown.Items.Add("26 : Set World Variable.")
        actiondropdown.Items.Add("27 : Set Economy Variable.")
        actiondropdown.Items.Add("28 : Say/Shout/Announce String")
        actiondropdown.Items.Add("29 : Run 80% of the way to my owner")
        actiondropdown.Items.Add("30 : Do Trigger")
        actiondropdown.Items.Add("31 : Attack my owner's target")
        actiondropdown.Items.Add("32 : Set PK flag for specified Zone")
        actiondropdown.Items.Add("33 : Set Regen mode for specified Zone")
        actiondropdown.Items.Add("34 : Give item(s) to my owner")
        actiondropdown.Items.Add("35 : Set AI Variable")
        actiondropdown.Items.Add("36 : Spawn monster at my location. Summon?")
        actiondropdown.Items.Add("37 : Spawn monster in circle (various location options). Summon?")

    End Sub

    Private Sub condlist_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles conddropdown.SelectedIndexChanged
        OpMode = 0
        DispCondData()
    End Sub
    Private Sub actiondropdown_SelectedIndexChanged(sender As System.Object, e As System.EventArgs) Handles actiondropdown.SelectedIndexChanged
        OpMode = 0
        DispActionData()
    End Sub

    Private Sub TextBox8_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CurrentCondOpcode.TextChanged

    End Sub
    Private Sub DispCondData()
        Dim t As Integer
        Dim iValue, iCount As Integer
        Dim iDistance, sVal1 As Integer
        Dim btDate, btHour1, btHour2, btMin1, btMin2, iDif1, iDif2, sCh1, sCh2 As Integer
        Dim ulTime, ulEndtime, ulNPC1 As Long
        Dim btOp, RecOrGive, btIsAllied, btMoreLess, btAbType, btWhen As Byte
        Dim btCheckTarget, btStatusType, btHave, btVarIdx As Byte
        Dim cond As String
        'clear all the labels. make them invisible
        CondDataCountLabel.Visible = False
        CondDataCount.Visible = False
        condlabel1.Visible = False  '1
        condlabel2.Visible = False  '2
        condlabel3.Visible = False  '3
        condlabel4.Visible = False  '4
        CondLabel5.Visible = False  '5
        CondLabel6.Visible = False  '6
        CondLabel7.Visible = False  '7
        CondDatalabel1.Visible = False  '11
        CondDataLabel2.Visible = False  '12
        CondDataLabel3.Visible = False  '13
        CondDataLabel4.Visible = False  '14
        CondDataLabel5.Visible = False  '15
        condTF1.Visible = False     '21
        CondbtOp1.Visible = False   '22
        condcombo1.Visible = False  '31
        CondCombo2.Visible = False  '32
        CondCombo3.Items.Clear()
        CondCombo3.Visible = False  '33
        condoption1.Visible = False  '41
        For t = 1 To 50
            TBL(t) = 0
        Next
        If OpMode = 1 Then
            ThisCondOpCode = ThisRecord.Conditions(CondIndex).Command - 67108865
            For t = 0 To ThisRecord.Conditions(CondIndex).Length - 9
                'TBL(t) = ThisRecord.Conditions(CondIndex).Bytes(t)
                TBL(t) = TempCondBytes(t)
            Next t
        Else
            ThisCondOpCode = conddropdown.SelectedIndex
        End If

        t = t
        Select Case ThisCondOpCode
            Case 0
                'Not used
            Case 1
                condlabel1.Text = "Opcode 1: Check Damage taken. TRUE if I have "
                condlabel2.Text = "or more points of damage. (inflicted not supported in some versions)"
                If OpMode = 1 Then
                    iValue = FindVal(TBL(1), TBL(0), 0, 0, 2)
                    RecOrGive = FindVal(TBL(4), 0, 0, 0, 1)
                Else
                    LoadtempCondBytes("0 0 0 0 0 205 205 205")
                End If
                t = t
                CondDatalabel1.Text = GiveRec(RecOrGive)
                CondDataLabel1_start = 4
                CondDataLabel1_len = 1
                CondDataLabel2.Text = iValue
                CondDataLabel2_start = 0
                CondDataLabel2_len = 2
                SetCondFormat(1, 11, 12, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0)
            Case 2
                condlabel1.Text = "Opcode 2: Check Near"
                condlabel2.Text = "within distance"
                condlabel3.Text = "with relative level"
                condlabel4.Text = "to"
                CondLabel5.Text = "TRUE if we find at least"
                CondLabel6.Text = "Sets FindChar & NearChar"
                If OpMode = 1 Then
                    iDistance = FindVal(TBL(3), TBL(2), TBL(1), TBL(0), 4)
                    btIsAllied = FindVal(TBL(4), 0, 0, 0, 1)
                    iDif1 = FindVal(TBL(7), TBL(6), 0, 0, 2)
                    iDif2 = FindVal(TBL(9), TBL(8), 0, 0, 2)
                    iCount = FindVal(TBL(11), TBL(10), 0, 0, 2)
                Else
                    LoadtempCondBytes("1 0 0 0 0 205 1 0 1 0 1 0")
                End If
                t = t
                CondDatalabel1.Text = IsAllied(btIsAllied)
                CondDataLabel1_start = 4
                CondDataLabel1_len = 1
                CondDataLabel2.Text = iDistance
                CondDataLabel2_start = 0
                CondDataLabel2_len = 4
                CondDataLabel3.Text = iDif1
                CondDataLabel3_start = 6
                CondDataLabel3_len = 2
                CondDataLabel4.Text = iDif2
                CondDataLabel4_start = 8
                CondDataLabel4_len = 2
                CondDataLabel5.Text = iCount
                CondDataLabel5_start = 10
                CondDataLabel5_len = 2
                SetCondFormat(1, 11, 2, 12, 3, 13, 4, 14, 5, 15, 6, 0, 0)
            Case 3
                condlabel1.Text = "Opcode 3: Check Distance from my spawn point: TRUE if >="
                If OpMode = 1 Then
                    iDistance = FindVal(TBL(3), TBL(2), TBL(1), TBL(0), 4)
                Else
                    LoadtempCondBytes("1 0 0 0")
                End If
                CondDatalabel1.Text = iDistance
                CondDataLabel1_start = 0
                CondDataLabel1_len = 4
                SetCondFormat(1, 11, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0)
            Case 4
                condlabel1.Text = "Opcode 4: Check Distance to my Target: TRUE if"
                If OpMode = 1 Then
                    iDistance = FindVal(TBL(3), TBL(2), TBL(1), TBL(0), 4)
                    btMoreLess = FindVal(TBL(4), 0, 0, 0, 1)
                Else
                    LoadtempCondBytes("1 0 0 0 0 205 205 205")
                End If
                CondDatalabel1.Text = MoreLess(btMoreLess)
                CondDataLabel1_start = 4
                CondDataLabel1_len = 1
                CondDataLabel2.Text = iDistance
                CondDataLabel2_start = 0
                CondDataLabel2_len = 4
                SetCondFormat(1, 11, 12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0)
            Case 5
                condlabel1.Text = "Opcode 5: Check ability of my Target: TRUE if"
                condlabel2.Text = "is"
                If OpMode = 1 Then
                    btAbType = FindVal(TBL(0), 0, 0, 0, 1)
                    iValue = FindVal(TBL(7), TBL(6), TBL(5), TBL(4), 4)
                    btMoreLess = FindVal(TBL(8), 0, 0, 0, 1)
                Else
                    LoadtempCondBytes("0 205 205 205 1 0 0 0 0 205 205 205")
                End If
                CondDatalabel1.Text = MoreLess(btMoreLess)
                CondDataLabel1_start = 8
                CondDataLabel1_len = 1
                CondDataLabel2.Text = GetABoption(btAbType)
                CondDataLabel2_start = 0
                CondDataLabel2_len = 1
                CondDataLabel3.Text = iValue
                CondDataLabel3_start = 4
                CondDataLabel3_len = 4
                SetCondFormat(1, 12, 2, 11, 13, 0, 0, 0, 0, 0, 0, 0, 0)
            Case 6
                condlabel1.Text = "Opcode 6: Check Percent HP:"
                condlabel2.Text = "Return TRUE if my current HP is"
                If OpMode = 1 Then
                    iValue = FindVal(TBL(3), TBL(2), TBL(1), TBL(0), 4)
                    btMoreLess = FindVal(TBL(4), 0, 0, 0, 1)
                Else
                    LoadtempCondBytes("0 0 0 0 0 205 205 205 205")
                End If
                CondDatalabel1.Text = MoreLess(btMoreLess)
                CondDataLabel1_start = 1
                CondDataLabel1_len = 1
                CondDataLabel2.Text = iValue
                CondDataLabel2_start = 16
                CondDataLabel2_len = 4
                SetCondFormat(1, 2, 11, 12, 0, 0, 0, 0, 0, 0, 0, 0, 0)
            Case 7
                condlabel1.Text = "Opcode 7: Random chance: TRUE if random number (0 - 100) is less than"
                If OpMode = 1 Then
                    iValue = FindVal(TBL(0), 0, 0, 0, 1)
                Else
                    LoadtempCondBytes("50 205 205 205")
                End If
                CondDatalabel1.Text = iValue
                CondDataLabel1_start = 0
                CondDataLabel1_len = 1
                SetCondFormat(1, 11, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0)
            Case 8
                condlabel1.Text = "Opcode 8: Check Near"
                condlabel2.Text = "within distance"
                condlabel3.Text = "TRUE if we find at least"
                condlabel4.Text = "with relative level"
                CondLabel5.Text = "to"
                CondLabel6.Text = "Sets FindChar & NearChar"
                If OpMode = 1 Then
                    iDistance = FindVal(TBL(3), TBL(2), TBL(1), TBL(0), 4)
                    btIsAllied = FindVal(TBL(4), 0, 0, 0, 1)
                    iDif1 = FindVal(TBL(7), TBL(6), 0, 0, 2)
                    iDif2 = FindVal(TBL(9), TBL(8), 0, 0, 2)
                    iCount = FindVal(TBL(11), TBL(10), 0, 0, 2)
                Else
                    LoadtempCondBytes("1 0 0 0 0 0 1 0 1 0 1 0")
                End If
                t = t
                CondDatalabel1.Text = IsAllied(btIsAllied)
                CondDataLabel1_start = 4
                CondDataLabel1_len = 1
                CondDataLabel2.Text = iDistance
                CondDataLabel2_start = 0
                CondDataLabel2_len = 4
                CondDataLabel3.Text = iDif1
                CondDataLabel3_start = 6
                CondDataLabel3_len = 2
                CondDataLabel4.Text = iDif2
                CondDataLabel4_start = 8
                CondDataLabel4_len = 2
                CondDataLabel5.Text = 1
                CondDataLabel5_start = 10
                CondDataLabel5_len = 2
                SetCondFormat(1, 11, 2, 12, 3, 15, 4, 13, 5, 14, 6, 0, 0)
            Case 9
                condlabel1.Text = "Opcode 9: Check Targets: True if I was just hit by someone who is NOT my target"
                If OpMode = 1 Then
                Else
                    LoadtempCondBytes("")
                End If
                SetCondFormat(1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0)
            Case 10
                condlabel1.Text = "Opcode 10: Check Ability: True if"
                condlabel2.Text = "of my Attacker is"
                condlabel3.Text = "than that of my Target"
                If OpMode = 1 Then
                    btAbType = FindVal(TBL(0), 0, 0, 0, 1)
                    btMoreLess = FindVal(TBL(1), 0, 0, 0, 1)
                Else
                    LoadtempCondBytes("0 0 205 205")
                End If
                CondDatalabel1.Text = MoreLess(btMoreLess)
                CondDataLabel1_start = 1
                CondDataLabel1_len = 1
                CondDataLabel2.Text = GetABoption(btAbType)
                CondDataLabel2_start = 0
                CondDataLabel2_len = 1
                SetCondFormat(1, 12, 2, 11, 3, 0, 0, 0, 0, 0, 0, 0, 0)
            Case 11
                condlabel1.Text = "Opcode 11: Check Ability: TRUE if my Attacker's"
                If OpMode = 1 Then
                    btAbType = FindVal(TBL(0), 0, 0, 0, 1)
                    iValue = FindVal(TBL(7), TBL(6), TBL(5), TBL(4), 4)
                    btMoreLess = FindVal(TBL(8), 0, 0, 0, 1)
                Else
                    LoadtempCondBytes("0 205 205 205 0 0 0 0 0 205 205 205")
                End If
                CondDatalabel1.Text = MoreLess(btMoreLess)
                CondDataLabel1_start = 8
                CondDataLabel1_len = 1
                CondDataLabel2.Text = GetABoption(btAbType)
                CondDataLabel2_start = 0
                CondDataLabel2_len = 1
                CondDataLabel3.Text = iValue
                CondDataLabel3_start = 4
                CondDataLabel3_len = 4
                SetCondFormat(1, 12, 11, 13, 0, 0, 0, 0, 0, 0, 0, 0, 0)
            Case 12
                condlabel1.Text = "Opcode 12: Check Zone Time: TRUE if it is currently"
                If OpMode = 1 Then
                    btWhen = FindVal(TBL(0), 0, 0, 0, 1)
                Else
                    LoadtempCondBytes("1 205 205 205")
                End If
                CondDataLabel2.Text = Getdaynight(btWhen)
                CondDataLabel2_start = 0
                CondDataLabel2_len = 1
                SetCondFormat(1, 12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0)
            Case 13
                condlabel1.Text = "Opcode 13: Check"
                condlabel2.Text = "for"
                condlabel3.Text = "TRUE if"
                CondDatalabel1.Text = "1000"
                If OpMode = 1 Then
                    btCheckTarget = CStr(FindVal(TBL(0), 0, 0, 0, 1))
                    btStatusType = CStr(FindVal(TBL(1), 0, 0, 0, 1))
                    btHave = CStr(FindVal(TBL(2), 0, 0, 0, 1))
                Else
                    LoadtempCondBytes("0 0 0 205")
                End If
                CondDatalabel1.Text = GetCheckTarget(btCheckTarget)
                CondDataLabel1_start = 0
                CondDataLabel1_len = 1
                CondDataLabel2.Text = GetStatusType(btStatusType)
                CondDataLabel2_start = 1
                CondDataLabel2_len = 1
                CondDataLabel3.Text = GetHave(btHave)
                CondDataLabel3_start = 2
                CondDataLabel3_len = 1
                SetCondFormat(1, 11, 2, 12, 3, 13, 0, 0, 0, 0, 0, 0, 0)
            Case 14
                condlabel1.Text = "Opcode 14: Check NPC Variable[" + CStr(RefVar) + "]["
                condlabel2.Text = "]. TRUE if value"
                If OpMode = 1 Then
                    btVarIdx = FindVal(TBL(0), 0, 0, 0, 1)
                    iValue = FindVal(TBL(7), TBL(6), TBL(5), TBL(4), 4)
                    btOp = FindVal(TBL(8), 0, 0, 0, 1)
                Else
                    LoadtempCondBytes("0 0 0 0 0 0 0 0 0 0 0 0")
                End If
                CondDatalabel1.Text = btVarIdx
                CondDataLabel1_start = 0
                CondDataLabel1_len = 1
                CondDataLabel2.Text = iValue
                CondDataLabel2_start = 4
                CondDataLabel2_len = 4
                CondbtOp1.Text = GetbtOp(btOp)
                CondbtOp1_start = 8
                CondbtOp1_len = 1
                SetCondFormat(1, 11, 2, 22, 12, 0, 0, 0, 0, 0, 0, 0, 0)
            Case 15
                condlabel1.Text = "Opcode 15: Check World Variable[" + CStr(WorldVar) + "]["
                condlabel2.Text = "]. TRUE if value"
                If OpMode = 1 Then
                    btVarIdx = FindVal(TBL(0), 0, 0, 0, 1)
                    iValue = FindVal(TBL(7), TBL(6), TBL(5), TBL(4), 4)
                    btOp = FindVal(TBL(8), 0, 0, 0, 1)
                Else
                    LoadtempCondBytes("0 0 0 0 0 0 0 0 0 0 0 0")
                End If
                CondDatalabel1.Text = btVarIdx
                CondDataLabel1_start = 0
                CondDataLabel1_len = 1
                CondDataLabel2.Text = iValue
                CondDataLabel2_start = 4
                CondDataLabel2_len = 4
                CondbtOp1.Text = GetbtOp(btOp)
                CondbtOp1_start = 8
                CondbtOp1_len = 1
                SetCondFormat(1, 11, 2, 22, 12, 0, 0, 0, 0, 0, 0, 0, 0)
            Case 16
                condlabel1.Text = "Opcode 16: Check Economy Variable[" + CStr(EconomyVar) + "]["
                condlabel2.Text = "]. TRUE if value"
                If OpMode = 1 Then
                    btVarIdx = FindVal(TBL(0), 0, 0, 0, 1)
                    iValue = FindVal(TBL(7), TBL(6), TBL(5), TBL(4), 4)
                    btOp = FindVal(TBL(8), 0, 0, 0, 1)
                Else
                    LoadtempCondBytes("0 0 0 0 0 0 0 0 0 0 0 0")
                End If
                CondDatalabel1.Text = btVarIdx
                CondDataLabel1_start = 0
                CondDataLabel1_len = 1
                CondDataLabel2.Text = iValue
                CondDataLabel2_start = 4
                CondDataLabel2_len = 4
                CondbtOp1.Text = GetbtOp(btOp)
                CondbtOp1_start = 8
                CondbtOp1_len = 1
                SetCondFormat(1, 11, 2, 22, 12, 0, 0, 0, 0, 0, 0, 0, 0)
            Case 17
                condlabel1.Text = "Opcode 17: Select NPC"
                If OpMode = 1 Then
                    ulNPC1 = FindVal(TBL(3), TBL(2), TBL(1), TBL(0), 4)
                Else
                    LoadtempCondBytes("0 0 0 0")
                End If
                CondDatalabel1.Text = ulNPC1
                CondDataLabel1_start = 0
                CondDataLabel1_len = 4
                SetCondFormat(1, 11, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0)
            Case 18
                condlabel1.Text = "Opcode 18: Check Distance to my owner. TRUE if"
                If OpMode = 1 Then
                    iDistance = FindVal(TBL(3), TBL(2), TBL(1), TBL(0), 4)
                    btOp = FindVal(TBL(4), 0, 0, 0, 1)
                Else
                    LoadtempCondBytes("0 0 0 0 0 0 0 0")
                End If
                CondbtOp1.Text = GetbtOp(btOp)
                CondbtOp1_start = 4
                CondbtOp1_len = 1
                CondDatalabel1.Text = iDistance
                CondDataLabel1_start = 0
                CondDataLabel1_len = 4
                SetCondFormat(1, 22, 11, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0)
            Case 19
                condlabel1.Text = "Opcode 19: Check Zone Time. TRUE if between"
                condlabel2.Text = "and"
                condlabel3.Text = "(inclusive)"
                If OpMode = 1 Then
                    ulTime = FindVal(TBL(3), TBL(2), TBL(1), TBL(0), 4)
                    ulEndtime = FindVal(TBL(7), TBL(6), TBL(5), TBL(4), 4)
                Else
                    LoadtempCondBytes("0 0 0 0 0 0 0 0")
                End If
                CondDatalabel1.Text = ulTime
                CondDataLabel1_start = 0
                CondDataLabel1_len = 4
                CondDataLabel2.Text = ulEndtime
                CondDataLabel2_start = 4
                CondDataLabel2_len = 4
                SetCondFormat(1, 11, 2, 12, 3, 0, 0, 0, 0, 0, 0, 0, 0)
            Case 20
                condlabel1.Text = "Opcode 20: Check My Ability. TRUE if my"
                If OpMode = 1 Then
                    btAbType = FindVal(TBL(0), 0, 0, 0, 1)
                    iValue = FindVal(TBL(7), TBL(6), TBL(5), TBL(4), 4)
                    btOp = FindVal(TBL(8), 0, 0, 0, 1)
                Else
                    LoadtempCondBytes("0 204 40 176 0 0 0 0 0 0 0 0")
                End If
                CondDataLabel2.Text = GetABoption(btAbType)
                CondDataLabel2_start = 0
                CondDataLabel2_len = 1
                CondbtOp1.Text = GetbtOp(btOp)
                CondbtOp1_start = 8
                CondbtOp1_len = 1
                CondDatalabel1.Text = iValue
                CondDataLabel1_start = 4
                CondDataLabel1_len = 4
                SetCondFormat(1, 12, 22, 11, 0, 0, 0, 0, 0, 0, 0, 0, 0)
            Case 21
                condlabel1.Text = "Opcode 21: Check my owner. TRUE if I do NOT have one"
                If OpMode = 1 Then
                Else
                    LoadtempCondBytes("")
                End If
                SetCondFormat(1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0)
            Case 22
                condlabel1.Text = "Opcode 22: Check if my owner has a target: TRUE if he does"
                If OpMode = 1 Then
                Else
                    LoadtempCondBytes("")
                End If
                SetCondFormat(1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0)
            Case 23
                condlabel1.Text = "Opcode 23: Check World Time. TRUE if between"
                condlabel2.Text = "and"
                condlabel3.Text = "(inclusive)"
                If OpMode = 1 Then
                    ulTime = FindVal(TBL(3), TBL(2), TBL(1), TBL(0), 4)
                    ulEndtime = FindVal(TBL(7), TBL(6), TBL(5), TBL(4), 4)
                Else
                    LoadtempCondBytes("0 0 0 0 0 0 0 0")
                End If
                CondDatalabel1.Text = ulTime
                CondDataLabel1_start = 0
                CondDataLabel1_len = 4
                CondDataLabel2.Text = ulEndtime
                CondDataLabel2_start = 4
                CondDataLabel2_len = 4
                SetCondFormat(1, 11, 2, 12, 3, 0, 0, 0, 0, 0, 0, 0, 0)
            Case 24
                condlabel1.Text = "Opcode 24: Check Date and Time (Date 0 runs every day): Date"
                condlabel2.Text = "Hour1"
                condlabel3.Text = "Min1"
                condlabel4.Text = "Hour2"
                CondLabel5.Text = "Min2"
                If OpMode = 1 Then
                    btDate = FindVal(TBL(0), 0, 0, 0, 1)
                    btHour1 = FindVal(TBL(1), 0, 0, 0, 1)
                    btMin1 = FindVal(TBL(2), 0, 0, 0, 1)
                    btHour2 = FindVal(TBL(3), 0, 0, 0, 1)
                    btMin2 = FindVal(TBL(4), 0, 0, 0, 1)
                Else
                    LoadtempCondBytes("0 0 0 0 0 0 0 0")
                End If
                CondDatalabel1.Text = btDate
                CondDataLabel1_start = 0
                CondDataLabel1_len = 1
                CondDataLabel2.Text = btHour1
                CondDataLabel2_start = 1
                CondDataLabel2_len = 1
                CondDataLabel3.Text = btMin1
                CondDataLabel3_start = 2
                CondDataLabel3_len = 1
                CondDataLabel4.Text = btHour2
                CondDataLabel4_start = 3
                CondDataLabel4_len = 1
                CondDataLabel5.Text = btMin2
                CondDataLabel5_start = 4
                CondDataLabel5_len = 1
                SetCondFormat(1, 11, 2, 12, 3, 13, 4, 14, 5, 15, 0, 0, 0)
            Case 25
                condlabel1.Text = "Opcode 25: Check WeekDay and Time: Day"
                condlabel2.Text = "Hour1"
                condlabel3.Text = "Min1"
                condlabel4.Text = "Hour2"
                CondLabel5.Text = "Min2"
                If OpMode = 1 Then
                    btDate = FindVal(TBL(0), 0, 0, 0, 1)
                    btHour1 = FindVal(TBL(1), 0, 0, 0, 1)
                    btMin1 = FindVal(TBL(2), 0, 0, 0, 1)
                    btHour2 = FindVal(TBL(3), 0, 0, 0, 1)
                    btMin2 = FindVal(TBL(4), 0, 0, 0, 1)
                Else
                    LoadtempCondBytes("0 0 0 0 0 0 0 0")
                End If
                CondDatalabel1.Text = btDate
                CondDataLabel1_start = 0
                CondDataLabel1_len = 1
                CondDataLabel2.Text = btHour1
                CondDataLabel2_start = 1
                CondDataLabel2_len = 1
                CondDataLabel3.Text = btMin1
                CondDataLabel3_start = 2
                CondDataLabel3_len = 1
                CondDataLabel4.Text = btHour2
                CondDataLabel4_start = 3
                CondDataLabel4_len = 1
                CondDataLabel5.Text = btMin2
                CondDataLabel5_start = 4
                CondDataLabel5_len = 1
                SetCondFormat(1, 11, 2, 12, 3, 13, 4, 14, 5, 15, 0, 0, 0)
            Case 26
                condlabel1.Text = "Opcode 26: Check Channel: TRUE if between"
                condlabel2.Text = "and"
                If OpMode = 1 Then
                    sCh1 = FindVal(TBL(1), TBL(0), 0, 0, 2)
                    sCh2 = FindVal(TBL(3), TBL(2), 0, 0, 2)
                Else
                    LoadtempCondBytes("0 0 0 0")
                End If
                CondDatalabel1.Text = sch1
                CondDataLabel1_start = 0
                CondDataLabel1_len = 2
                CondDataLabel2.Text = sch2
                CondDataLabel2_start = 2
                CondDataLabel2_len = 2
                SetCondFormat(1, 11, 2, 12, 0, 0, 0, 0, 0, 0, 0, 0, 0)
            Case 27
                condlabel1.Text = "Opcode 27: Check Near"
                condlabel2.Text = "within distance"
                condlabel3.Text = "with relative level"
                condlabel4.Text = "to"
                CondLabel5.Text = "TRUE if count"
                CondLabel6.Text = "Sets FindChar & NearChar"
                If OpMode = 1 Then
                    iDistance = FindVal(TBL(3), TBL(2), TBL(1), TBL(0), 4)
                    btIsAllied = FindVal(TBL(4), 0, 0, 0, 1)
                    iDif1 = FindVal(TBL(7), TBL(6), 0, 0, 2)
                    iDif2 = FindVal(TBL(9), TBL(8), 0, 0, 2)
                    iCount = FindVal(TBL(11), TBL(10), 0, 0, 2)
                    btOp = FindVal(TBL(12), 0, 0, 0, 1)
                Else
                    LoadtempCondBytes("1 0 0 0 0 205 0 1 0 1 0 1 0 205 205 205")
                End If
                t = t
                CondDatalabel1.Text = IsAllied(btIsAllied)
                CondDataLabel1_start = 4
                CondDataLabel1_len = 1
                CondDataLabel2.Text = iDistance
                CondDataLabel2_start = 0
                CondDataLabel2_len = 4
                CondDataLabel3.Text = iDif1
                CondDataLabel3_start = 6
                CondDataLabel3_len = 2
                CondDataLabel4.Text = iDif2
                CondDataLabel4_start = 8
                CondDataLabel4_len = 2
                CondDataLabel5.Text = iCount
                CondDataLabel5_start = 10
                CondDataLabel5_len = 2
                CondbtOp1.Text = GetbtOp(btOp)
                CondbtOp1_start = 12
                CondbtOp1_len = 1
                SetCondFormat(1, 11, 2, 12, 3, 13, 4, 14, 5, 22, 15, 6, 0)
            Case 28
                condlabel1.Text = "Opcode 28: Check AI Variable["
                condlabel2.Text = "]. TRUE if value"
                If OpMode = 1 Then
                    sVal1 = FindVal(TBL(1), TBL(0), 0, 0, 2)
                    iValue = FindVal(TBL(7), TBL(6), TBL(5), TBL(4), 4)
                    btOp = FindVal(TBL(8), 0, 0, 0, 1)
                Else
                    LoadtempCondBytes("0 0 205 205 0 0 0 0 0 205 205 205")
                End If
                CondDatalabel1.Text = sVal1
                CondDataLabel1_start = 0
                CondDataLabel1_len = 2
                CondDataLabel2.Text = iValue
                CondDataLabel2_start = 4
                CondDataLabel2_len = 4
                CondbtOp1.Text = GetbtOp(btOp)
                CondbtOp1_start = 2
                CondbtOp1_len = 1
                SetCondFormat(1, 11, 2, 22, 12, 0, 0, 0, 0, 0, 0, 0, 0)
            Case 29
                condlabel1.Text = "Opcode 29: Check Target. TRUE if Target type is"
                If OpMode = 1 Then
                    btCheckTarget = FindVal(TBL(0), 0, 0, 0, 1)
                Else
                    LoadtempCondBytes("0 205 205 205")
                End If
                CondDatalabel1.Text = GetCheckTarget(btCheckTarget)
                CondDataLabel1_start = 0
                CondDataLabel1_len = 1
                SetCondFormat(1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0)
            Case 30
                condlabel1.Text = "Opcode 30: Check Time since spawn. TRUE if I have been alive more than"
                condlabel2.Text = "seconds:"
                If OpMode = 1 Then
                    iValue = FindVal(TBL(3), TBL(2), TBL(1), TBL(0), 4)
                Else
                    LoadtempCondBytes("0 0 0 0")
                End If
                CondDatalabel1.Text = iValue
                CondDataLabel1_start = 0
                CondDataLabel1_len = 4
                SetCondFormat(1, 11, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0)
        End Select
        t = t
    End Sub
    Sub FormatCond()
        Dim t, lastcond, thiscond, leftpos As Integer
        condlabel1.Visible = True
        For t = 2 To 13
            thiscond = CondFormat(t)
            If thiscond <> 0 Then
                lastcond = CondFormat(t - 1)
                Select Case lastcond
                    Case 1
                        leftpos = condlabel1.Left + condlabel1.Width + 1
                    Case 2
                        leftpos = condlabel2.Left + condlabel2.Width + 1
                    Case 3
                        leftpos = condlabel3.Left + condlabel3.Width + 1
                    Case 4
                        leftpos = condlabel4.Left + condlabel4.Width + 1
                    Case 5
                        leftpos = CondLabel5.Left + CondLabel5.Width + 1
                    Case 6
                        leftpos = CondLabel6.Left + CondLabel6.Width + 1
                    Case 7
                        leftpos = CondLabel7.Left + CondLabel7.Width + 1
                    Case 8
                        leftpos = CondLabel8.Left + CondLabel8.Width + 1
                    Case 11
                        leftpos = CondDatalabel1.Left + CondDatalabel1.Width + 1
                    Case 12
                        leftpos = CondDataLabel2.Left + CondDataLabel2.Width + 1
                    Case 13
                        leftpos = CondDataLabel3.Left + CondDataLabel3.Width + 1
                    Case 14
                        leftpos = CondDataLabel4.Left + CondDataLabel4.Width + 1
                    Case 15
                        leftpos = CondDataLabel5.Left + CondDataLabel5.Width + 1
                    Case 21
                        leftpos = condTF1.Left + condTF1.Width + 1
                    Case 22
                        leftpos = CondbtOp1.Left + CondbtOp1.Width + 1
                    Case 31
                        leftpos = condcombo1.Left + condcombo1.Width + 1
                    Case 32
                        leftpos = CondCombo2.Left + CondCombo2.Width + 1
                    Case 41
                        leftpos = condoption1.Left + condoption1.Width + 1
                End Select
                Select Case thiscond
                    Case 2
                        condlabel2.Left = leftpos
                        condlabel2.Visible = True
                    Case 3
                        condlabel3.Left = leftpos
                        condlabel3.Visible = True
                    Case 4
                        condlabel4.Left = leftpos
                        condlabel4.Visible = True
                    Case 5
                        CondLabel5.Left = leftpos
                        CondLabel5.Visible = True
                    Case 6
                        CondLabel6.Left = leftpos
                        CondLabel6.Visible = True
                    Case 7
                        CondLabel7.Left = leftpos
                        CondLabel7.Visible = True
                    Case 8
                        CondLabel8.Left = leftpos
                        CondLabel8.Visible = True
                    Case 11
                        CondDatalabel1.Left = leftpos
                        CondDatalabel1.Visible = True
                    Case 12
                        CondDataLabel2.Left = leftpos
                        CondDataLabel2.Visible = True
                    Case 13
                        CondDataLabel3.Left = leftpos
                        CondDataLabel3.Visible = True
                    Case 14
                        CondDataLabel4.Left = leftpos
                        CondDataLabel4.Visible = True
                    Case 15
                        CondDataLabel5.Left = leftpos
                        CondDataLabel5.Visible = True
                    Case 21
                        condTF1.Left = leftpos
                        condTF1.Visible = True
                    Case 22
                        CondbtOp1.Left = leftpos
                        CondbtOp1.Visible = True
                    Case 31
                        condcombo1.Left = leftpos
                        condcombo1.Visible = True
                    Case 32
                        CondCombo2.Left = leftpos
                        CondCombo2.Visible = True
                    Case 41
                        condoption1.Left = leftpos
                        condoption1.Visible = True

                End Select
            End If
        Next
    End Sub
    Private Sub DispActionData()
        Dim t, i As Integer
        Dim iValue, iVarNo As Integer
        Dim sVal, monType As Integer
        Dim skillID, iZone As Integer
        Dim iTem1, iTem2, iTem3, iTem4, iTem5, iOwner, nMotion, iNameLen As Integer
        Dim iDistance, iStrID, iCount As Long
        Dim btOp, thisByte, btAbOption, btHighLow, btPos, btTarget, btMsgType, btOnOff As Byte
        Dim TriggerName, STRData As String
        'clear all the labels. make them invisible
        ActionDataCountLabel.Visible = False
        ActionDataCount.Visible = True
        actionlabel1.Visible = False  '1
        actionlabel2.Visible = False  '2
        Actionlabel3.Visible = False  '3
        Actionlabel4.Visible = False  '4
        ActionLabel5.Visible = False  '5
        ActionLabel6.Visible = False  '6
        ActionLabel7.Visible = False  '7
        actiondatalabel1.Visible = False  '11
        actiondatalabel2.Visible = False  '12
        actiondatalabel3.Visible = False  '13
        ActionDatalabel4.Visible = False  '14
        ActionDatalabel5.Visible = False  '15
        ActionDataLabel6.Visible = False  '16
        ActionDataLabel7.Visible = False  '17
        ActionDataCount.Visible = False
        actionTF1.Visible = False     '21 True / False
        actionAS1.Visible = False     '23 Add / Subtract
        ActionSOption1.Visible = False '24 sOption
        ActionQOption1.Visible = False  '25 quest var option
        ActionbtOp1.Visible = False  '31
        actioncombo2.Visible = False  '32
        ActionCombo4.Visible = False  '33  used for selection case
        actioncombo3.Items.Clear()
        actioncombo3.Visible = False  '33
        actionoption1.Visible = False  '41


        For t = 1 To 50
            TBL(t) = 0
        Next
        If OpMode = 1 Then
            ThisActionOpCode = ThisRecord.Actions(ActionIndex).Command - 184549377
            For t = 0 To ThisRecord.Actions(ActionIndex).Length - 9
                'TBL(t) = ThisRecord.Actions(ActionIndex).Bytes(t)
                TBL(t) = TempActionBytes(t)
            Next t
            CurrentActionOpcode.Text = ThisRecord.Actions(ActionIndex).Command
        Else
            ThisActionOpCode = actiondropdown.SelectedIndex
            CurrentActionOpcode.Text = ThisActionOpCode + 184549377
        End If

        t = t

        Select Case ThisActionOpCode
            Case 0 
                Actionlabel1.Text = "Opcode 0: Stop all actions"
                If OpMode = 1 Then
                Else 'set up an empty version of the tempActionByte array
                    LoadtempActionBytes("")
                End If
                SetActionFormat(1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0)
            Case 1
                Actionlabel1.Text = "Opcode 1: Set Emotion"
                Actionlabel2.Text = "(Does not appear to actually do anything)"
                If OpMode = 1 Then
                    thisByte = FindVal(TBL(0), 0, 0, 0, 1)
                Else
                    LoadtempActionBytes("0 205 205 205")
                End If
                actiondatalabel1.Text = thisByte
                ActionDataLabel1_start = 0
                ActionDataLabel1_len = 1
                SetActionFormat(1, 11, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0)
            Case 2
                Actionlabel1.Text = "Opcode 2: Say LTB string"
                If OpMode = 1 Then
                    iStrID = FindVal(TBL(3), TBL(2), TBL(1), TBL(0), 4)
                Else
                    LoadtempActionBytes("0 0 0 0")
                End If
                actiondatalabel1.Text = iStrID
                ActionDataLabel1_start = 0
                ActionDataLabel1_len = 4
                SetActionFormat(1, 11, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0)
            Case 3
                Actionlabel1.Text = "Opcode 3:"
                Actionlabel2.Text = "to a random position within"
                Actionlabel3.Text = "of present location"
                If OpMode = 1 Then
                    iDistance = FindVal(TBL(3), TBL(2), TBL(1), TBL(0), 4)
                    thisByte = FindVal(TBL(4), 0, 0, 0, 1)
                Else
                    LoadtempActionBytes("0 0 0 0 0 205 205 205")
                End If
                actiondatalabel1.Text = GetStance(thisByte)
                ActionDataLabel1_start = 4
                ActionDataLabel1_len = 1
                actiondatalabel2.Text = iDistance
                ActionDataLabel2_start = 0
                ActionDataLabel2_len = 4
                SetActionFormat(1, 11, 2, 12, 3, 0, 0, 0, 0, 0, 0, 0, 0)
            Case 4
                Actionlabel1.Text = "Opcode 4:"
                Actionlabel2.Text = "to a random position within"
                Actionlabel3.Text = "of my spawn location"
                If OpMode = 1 Then
                    iDistance = FindVal(TBL(3), TBL(2), TBL(1), TBL(0), 4)
                    thisByte = FindVal(TBL(4), 0, 0, 0, 1)
                Else
                    LoadtempActionBytes("0 0 0 0 0 205 205 205")
                End If
                actiondatalabel1.Text = GetStance(thisByte)
                ActionDataLabel1_start = 4
                ActionDataLabel1_len = 1
                actiondatalabel2.Text = iDistance
                ActionDataLabel2_start = 0
                ActionDataLabel2_len = 4
                SetActionFormat(1, 11, 2, 12, 3, 0, 0, 0, 0, 0, 0, 0, 0)
            Case 5
                Actionlabel1.Text = "Opcode 5:"
                Actionlabel2.Text = "to a random position within 2 of FindChar"
                If OpMode = 1 Then
                    thisByte = FindVal(TBL(0), 0, 0, 0, 1)
                Else
                    LoadtempActionBytes("0 205 205 205")
                End If
                actiondatalabel1.Text = GetStance(thisByte)
                ActionDataLabel1_start = 4
                ActionDataLabel1_len = 1
                SetActionFormat(1, 11, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0)
            Case 6
                Actionlabel1.Text = "Opcode 6: Run and attack Character with"
                Actionlabel2.Text = "within range"
                If OpMode = 1 Then
                    iDistance = FindVal(TBL(3), TBL(2), TBL(1), TBL(0), 4)
                    btAbOption = FindVal(TBL(4), 0, 0, 0, 1)
                    btHighLow = FindVal(TBL(5), 0, 0, 0, 1)
                Else
                    LoadtempActionBytes("0 0 0 0 0 0 205 205")
                End If
                actiondatalabel1.Text = GetABoption(btAbOption)
                ActionDataLabel1_start = 4
                ActionDataLabel1_len = 1
                actiondatalabel2.Text = GetHighLow(btHighLow)
                ActionDataLabel2_start = 5
                ActionDataLabel2_len = 1
                actiondatalabel3.Text = iDistance
                ActionDataLabel3_start = 0
                ActionDataLabel3_len = 4
                SetActionFormat(1, 12, 11, 2, 13, 0, 0, 0, 0, 0, 0, 0, 0)
            Case 7
                Actionlabel1.Text = "Opcode 7: Do Secial Attack"
                If OpMode = 1 Then
                Else
                    LoadtempActionBytes("")
                End If
                SetActionFormat(1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0)
            Case 8
                Actionlabel1.Text = "Opcode 8:"
                Actionlabel2.Text = "towards my Target. Stop"
                Actionlabel3.Text = "% away from Target"
                If OpMode = 1 Then
                    iDistance = FindVal(TBL(3), TBL(2), TBL(1), TBL(0), 4)
                    thisByte = FindVal(TBL(4), 0, 0, 0, 1)
                Else
                    LoadtempActionBytes("0 0 0 0 0 205 205 205")
                End If
                actiondatalabel1.Text = GetStance(thisByte)
                ActionDataLabel1_start = 4
                ActionDataLabel1_len = 1
                actiondatalabel2.Text = iDistance
                ActionDataLabel2_start = 0
                ActionDataLabel2_len = 4
                SetActionFormat(1, 11, 2, 12, 3, 0, 0, 0, 0, 0, 0, 0, 0)
            Case 9
                Actionlabel1.Text = "Opcode 9: Convert to monster with id"
                If OpMode = 1 Then
                    monType = FindVal(TBL(1), TBL(0), 0, 0, 2)
                Else
                    LoadtempActionBytes("0 0 205 205")
                End If
                actiondatalabel1.Text = monType
                ActionDataLabel1_start = 0
                ActionDataLabel1_len = 2
                SetActionFormat(1, 11, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0)
            Case 10
                Actionlabel1.Text = "Opcode 10: Spawn monster with id"
                Actionlabel2.Text = "at my current location"
                If OpMode = 1 Then
                    monType = FindVal(TBL(1), TBL(0), 0, 0, 2)
                Else
                    LoadtempActionBytes("0 0 205 205")
                End If
                actiondatalabel1.Text = monType
                ActionDataLabel1_start = 0
                ActionDataLabel1_len = 2
                SetActionFormat(1, 11, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0)
            Case 11
                Actionlabel1.Text = "Opcode 11: Call for help. Force"
                Actionlabel2.Text = "allies within range"
                Actionlabel3.Text = "to attack my target."
                If OpMode = 1 Then
                    iDistance = FindVal(TBL(3), TBL(2), TBL(1), TBL(0), 4)
                    icount = FindVal(TBL(7), TBL(6), TBL(5), TBL(4), 4)
                Else
                    LoadtempActionBytes("0 0 0 0 0 0 0 0")
                End If
                actiondatalabel1.Text = iDistance
                ActionDataLabel1_start = 4
                ActionDataLabel1_len = 4
                actiondatalabel2.Text = iCount
                ActionDataLabel2_start = 0
                ActionDataLabel2_len = 4
                SetActionFormat(1, 12, 2, 11, 3, 0, 0, 0, 0, 0, 0, 0, 0)
            Case 12
                Actionlabel1.Text = "Opcode 12: Initiate combat with NearChar"
                If OpMode = 1 Then
                Else
                    LoadtempActionBytes("")
                End If
                SetActionFormat(1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0)
            Case 13
                Actionlabel1.Text = "Opcode 13: Initiate combat with FindChar"
                If OpMode = 1 Then
                Else
                    LoadtempActionBytes("")
                End If
                SetActionFormat(1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0)
            Case 14
                Actionlabel1.Text = "Opcode 14: Call for help. Force all allies with the same monster type within range"
                Actionlabel2.Text = "to attack my target."
                If OpMode = 1 Then
                    iDistance = FindVal(TBL(3), TBL(2), TBL(1), TBL(0), 4)
                Else
                    LoadtempActionBytes("0 0 0 0")
                End If
                actiondatalabel1.Text = iDistance
                ActionDataLabel1_start = 0
                ActionDataLabel1_len = 4
                SetActionFormat(1, 11, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0)
            Case 15
                Actionlabel1.Text = "Opcode 15: Switch target. Attack the enemy that just hit me"
                If OpMode = 1 Then
                Else
                    LoadtempActionBytes("")
                End If
                SetActionFormat(1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0)
            Case 16
                Actionlabel1.Text = "Opcode 16: Run away to a random location within "
                Actionlabel2.Text = "of my spawn point"
                If OpMode = 1 Then
                    iDistance = FindVal(TBL(3), TBL(2), TBL(1), TBL(0), 4)
                Else
                    LoadtempActionBytes("0 0 0 0")
                End If
                actiondatalabel1.Text = iDistance
                ActionDataLabel1_start = 0
                ActionDataLabel1_len = 4
                SetActionFormat(1, 11, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0)
            Case 17
                Actionlabel1.Text = "Opcode 17: Drop one of 5 items"
                Actionlabel2.Text = "Owned by first hitter?"
                If OpMode = 1 Then
                    iTem1 = FindVal(TBL(1), TBL(0), 0, 0, 2)
                    iTem2 = FindVal(TBL(3), TBL(2), 0, 0, 2)
                    iTem3 = FindVal(TBL(5), TBL(4), 0, 0, 2)
                    iTem4 = FindVal(TBL(7), TBL(6), 0, 0, 2)
                    iTem5 = FindVal(TBL(9), TBL(8), 0, 0, 2)
                    iOwner = FindVal(TBL(15), TBL(14), TBL(13), TBL(12), 4)
                Else
                    LoadtempActionBytes("0 0 0 0 0 0 0 0 0 0 205 205 0 0 0 0")
                End If
                actiondatalabel1.Text = iTem1
                ActionDataLabel1_start = 0
                ActionDataLabel1_len = 2
                actiondatalabel2.Text = iTem2
                ActionDataLabel2_start = 2
                ActionDataLabel2_len = 2
                actiondatalabel3.Text = iTem3
                ActionDataLabel3_start = 4
                ActionDataLabel3_len = 2
                ActionDatalabel4.Text = iTem4
                ActionDataLabel4_start = 6
                ActionDataLabel4_len = 2
                ActionDatalabel5.Text = iTem5
                ActionDataLabel5_start = 8
                ActionDataLabel5_len = 2
                actionTF1.Text = GetTF(iOwner)
                ActionTF1_start = 12
                ActionTF1_len = 4
                SetActionFormat(1, 11, 12, 13, 14, 15, 2, 21, 0, 0, 0, 0, 0)
            Case 18
                Actionlabel1.Text = "Opcode 18: Call for help. Force"
                Actionlabel2.Text = "monsters of type"
                Actionlabel3.Text = "within range"
                Actionlabel4.Text = "to attack my target"
                If OpMode = 1 Then
                    monType = FindVal(TBL(1), TBL(0), 0, 0, 2)
                    iCount = FindVal(TBL(3), TBL(2), 0, 0, 2)
                    iDistance = FindVal(TBL(7), TBL(6), TBL(5), TBL(4), 4)
                Else
                    LoadtempActionBytes("0 0 0 0 0 0 0 0")
                End If
                actiondatalabel1.Text = iCount
                ActionDataLabel1_start = 0
                ActionDataLabel1_len = 2
                actiondatalabel2.Text = monType
                ActionDataLabel2_start = 2
                ActionDataLabel2_len = 2
                actiondatalabel3.Text = iDistance
                ActionDataLabel3_start = 4
                ActionDataLabel3_len = 4
                SetActionFormat(1, 11, 2, 12, 3, 13, 4, 0, 0, 0, 0, 0, 0)
            Case 19
                Actionlabel1.Text = "Opcode 19: Initiate combat with NearChar"
                If OpMode = 1 Then
                Else
                    LoadtempActionBytes("")
                End If
                SetActionFormat(1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0)
            Case 20
                Actionlabel1.Text = "Opcode 20: Spawn 1 monster of type"
                Actionlabel2.Text = "within"
                Actionlabel3.Text = "meters of"
                If OpMode = 1 Then
                    monType = FindVal(TBL(1), TBL(0), 0, 0, 2)
                    btPos = FindVal(TBL(2), 0, 0, 0, 1)
                    iDistance = FindVal(TBL(7), TBL(6), TBL(5), TBL(4), 4)
                Else
                    sVal = 0
                    LoadtempActionBytes("0 0 0 205 0 0 0 0")
                End If
                actiondatalabel1.Text = monType
                ActionDataLabel1_start = 0
                ActionDataLabel1_len = 2
                actiondatalabel2.Text = GetbtPos(btPos)
                ActionDataLabel2_start = 2
                ActionDataLabel2_len = 1
                actiondatalabel3.Text = iDistance
                ActionDataLabel3_start = 4
                ActionDataLabel3_len = 4
                SetActionFormat(1, 11, 2, 13, 3, 12, 0, 0, 0, 0, 0, 0, 0)
            Case 21
                Actionlabel1.Text = "Opcode 21: unused"
                If OpMode = 1 Then
                Else
                    LoadtempActionBytes("")
                End If
                SetActionFormat(1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0)
            Case 22
                Actionlabel1.Text = "Opcode 22: unused"
                If OpMode = 1 Then
                Else
                    LoadtempActionBytes("")
                End If
                SetActionFormat(1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0)
            Case 23
                Actionlabel1.Text = "Opcode 23: Commit suicide"
                If OpMode = 1 Then
                Else
                    LoadtempActionBytes("")
                End If
                SetActionFormat(1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0)
            Case 24
                Actionlabel1.Text = "Opcode 24: Do skill"
                Actionlabel2.Text = "Skill is"
                If OpMode = 1 Then
                    btTarget = FindVal(TBL(0), 0, 0, 0, 1)
                    skillID = FindVal(TBL(3), TBL(2), 0, 0, 2)
                    nMotion = FindVal(TBL(5), TBL(4), 0, 0, 2)
                Else
                    LoadtempActionBytes("0 205 0 0 0 0 205 205")
                End If
                actiondatalabel1.Text = skillID
                ActionDataLabel1_start = 2
                ActionDataLabel1_len = 2
                actiondatalabel2.Text = GetbtTarget(btTarget)
                ActionDataLabel2_start = 0
                ActionDataLabel2_len = 1
                actiondatalabel3.Text = GetnMotion(nMotion)
                ActionDataLabel3_start = 4
                ActionDataLabel3_len = 2
                SetActionFormat(1, 11, 2, 12, 13, 0, 0, 0, 0, 0, 0, 0, 0)
            Case 25
                Actionlabel1.Text = "Opcode 25: Set Object Variable [ " + CStr(RefVar) + " ] ["
                Actionlabel2.Text = "]"
                If OpMode = 1 Then
                    iVarNo = FindVal(TBL(1), TBL(0), 0, 0, 2)
                    iValue = FindVal(TBL(7), TBL(6), TBL(5), TBL(4), 4)
                    btOp = FindVal(TBL(8), 0, 0, 0, 1)
                Else
                    LoadtempActionBytes("0 0 0 0 0 0 0 0 0 0 0 0")
                End If
                actiondatalabel1.Text = iVarNo
                ActionDataLabel1_start = 0
                ActionDataLabel1_len = 2
                actiondatalabel2.Text = iValue
                ActionDataLabel2_start = 4
                ActionDataLabel2_len = 4
                ActionbtOp1.Text = GetbtOp(btOp)
                ActionbtOp1_start = 8
                ActionbtOp1_len = 1
                SetActionFormat(1, 11, 2, 31, 12, 0, 0, 0, 0, 0, 0, 0, 0)
            Case 26
                Actionlabel1.Text = "Opcode 26: Set World Variable ["
                Actionlabel2.Text = "]"
                If OpMode = 1 Then
                    iVarNo = FindVal(TBL(1), TBL(0), 0, 0, 2)
                    iValue = FindVal(TBL(7), TBL(6), TBL(5), TBL(4), 4)
                    btOp = FindVal(TBL(8), 0, 0, 0, 1)
                Else
                    LoadtempActionBytes("0 0 0 0 0 0 0 0 0 0 0 0")
                End If
                actiondatalabel1.Text = iVarNo
                ActionDataLabel1_start = 0
                ActionDataLabel1_len = 2
                actiondatalabel2.Text = iValue
                ActionDataLabel2_start = 4
                ActionDataLabel2_len = 4
                ActionbtOp1.Text = GetbtOp(btOp)
                ActionbtOp1_start = 8
                ActionbtOp1_len = 1
                SetActionFormat(1, 11, 2, 31, 12, 0, 0, 0, 0, 0, 0, 0, 0)
            Case 27
                Actionlabel1.Text = "Opcode 27: Set Ecomony Variable ["
                Actionlabel2.Text = "]"
                If OpMode = 1 Then
                    iVarNo = FindVal(TBL(1), TBL(0), 0, 0, 2)
                    iValue = FindVal(TBL(7), TBL(6), TBL(5), TBL(4), 4)
                    btOp = FindVal(TBL(8), 0, 0, 0, 1)
                Else
                    LoadtempActionBytes("0 0 0 0 0 0 0 0 0 0 0 0")
                End If
                actiondatalabel1.Text = iVarNo
                ActionDataLabel1_start = 0
                ActionDataLabel1_len = 2
                actiondatalabel2.Text = iValue
                ActionDataLabel2_start = 4
                ActionDataLabel2_len = 4
                ActionbtOp1.Text = GetbtOp(btOp)
                ActionbtOp1_start = 8
                ActionbtOp1_len = 1
                SetActionFormat(1, 11, 2, 31, 12, 0, 0, 0, 0, 0, 0, 0, 0)
            Case 28
                Actionlabel1.Text = "Opcode 28:"
                Actionlabel2.Text = "LTB String:"
                If OpMode = 1 Then
                    btMsgType = FindVal(TBL(0), 0, 0, 0, 1)
                    iValue = FindVal(TBL(7), TBL(6), TBL(5), TBL(4), 4)
                Else
                    LoadtempActionBytes("0 205 205 205 0 0 0 0")
                End If
                actiondatalabel1.Text = GetMsgType(btMsgType)
                ActionDataLabel1_start = 0
                ActionDataLabel1_len = 1
                actiondatalabel2.Text = iValue
                ActionDataLabel2_start = 4
                ActionDataLabel2_len = 4
                SetActionFormat(1, 11, 2, 12, 0, 0, 0, 0, 0, 0, 0, 0, 0)
            Case 29
                Actionlabel1.Text = "Opcode 29: Run towards my owner. Stop 20% from him"
                If OpMode = 1 Then
                Else
                    LoadtempActionBytes("")
                    STRData = ""
                End If
                SetActionFormat(1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0)
            Case 30
                Actionlabel1.Text = "Opcode 30: Execute Quest Trigger"
                If OpMode = 1 Then
                    iNameLen = FindVal(TBL(1), TBL(0), 0, 0, 2)
                    TriggerName = ""
                    For i = 0 To iNameLen
                        TriggerName = TriggerName + Chr(TBL(i + 2))
                    Next
                Else
                    LoadtempActionBytes("0 0 0 0 0 0 0 0 0 0 0 0")
                    TriggerName = ""
                End If
                actiondatalabel1.Text = TriggerName
                SetActionFormat(1, 11, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0)
            Case 31
                Actionlabel1.Text = "Opcode 31: Set my Target to the same as my owner"
                If OpMode = 1 Then
                Else
                    LoadtempActionBytes("")
                End If
                SetActionFormat(1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0)
            Case 32
                Actionlabel1.Text = "Opcode 32: Set PVP toggle for zone"
                Actionlabel2.Text = "to"
                If OpMode = 1 Then
                    iZone = FindVal(TBL(1), TBL(0), 0, 0, 2)
                    btOnOff = FindVal(TBL(2), 0, 0, 0, 1)
                Else
                    LoadtempActionBytes("0 0 0 0")
                End If
                actiondatalabel1.Text = iZone
                ActionDataLabel1_start = 0
                ActionDataLabel1_len = 2
                actiondatalabel2.Text = GetOnOff(btOnOff)
                ActionDataLabel2_start = 2
                ActionDataLabel2_len = 1
                SetActionFormat(1, 11, 2, 12, 0, 0, 0, 0, 0, 0, 0, 0, 0)
            Case 33
                Actionlabel1.Text = "Opcode 33: Set Regen Mode toggle for zone"
                Actionlabel2.Text = "to"
                If OpMode = 1 Then
                    iZone = FindVal(TBL(1), TBL(0), 0, 0, 2)
                    btOnOff = FindVal(TBL(2), 0, 0, 0, 1)
                Else
                    LoadtempActionBytes("0 0 0 0")
                End If
                actiondatalabel1.Text = iZone
                ActionDataLabel1_start = 0
                ActionDataLabel1_len = 2
                actiondatalabel2.Text = GetOnOff(btOnOff)
                ActionDataLabel2_start = 2
                ActionDataLabel2_len = 1
                SetActionFormat(1, 11, 2, 12, 0, 0, 0, 0, 0, 0, 0, 0, 0)
            Case 34
                Actionlabel1.Text = "Opcode 34: Give"
                Actionlabel2.Text = "item with id"
                Actionlabel3.Text = "to my owner"
                If OpMode = 1 Then
                    iTem1 = FindVal(TBL(1), TBL(0), 0, 0, 2)
                    iCount = FindVal(TBL(3), TBL(2), 0, 0, 2)
                Else
                    LoadtempActionBytes("0 0 0 0")
                End If
                actiondatalabel1.Text = iCount
                ActionDataLabel1_start = 0
                ActionDataLabel1_len = 2
                actiondatalabel2.Text = iTem1
                ActionDataLabel2_start = 2
                ActionDataLabel2_len = 2
                SetActionFormat(1, 11, 2, 12, 3, 0, 0, 0, 0, 0, 0, 0, 0)
            Case 35
                Actionlabel1.Text = "Opcode 35: Set AI Variable ["
                Actionlabel2.Text = "]"
                If OpMode = 1 Then
                    iVarNo = FindVal(TBL(1), TBL(0), 0, 0, 2)
                    iValue = FindVal(TBL(7), TBL(6), TBL(5), TBL(4), 4)
                    btOp = FindVal(TBL(8), 0, 0, 0, 1)
                Else
                    LoadtempActionBytes("0 0 205 205 0 0 0 0 0 205 205 205")
                End If
                actiondatalabel1.Text = iVarNo
                ActionDataLabel1_start = 0
                ActionDataLabel1_len = 2
                actiondatalabel2.Text = iValue
                ActionDataLabel2_start = 4
                ActionDataLabel2_len = 4
                ActionbtOp1.Text = GetbtOp(btOp)
                ActionbtOp1_start = 8
                ActionbtOp1_len = 1
                SetActionFormat(1, 11, 2, 31, 12, 0, 0, 0, 0, 0, 0, 0, 0)
            Case 36
                Actionlabel1.Text = "Opcode 36: Spawn 1 monster of type"
                Actionlabel2.Text = "at my current position"
                If OpMode = 1 Then
                    monType = FindVal(TBL(1), TBL(0), 0, 0, 2)
                    thisByte = FindVal(TBL(2), 0, 0, 0, 1)
                Else
                    LoadtempActionBytes("0 0 0 205")
                End If
                actiondatalabel1.Text = monType
                ActionDataLabel1_start = 0
                ActionDataLabel1_len = 2
                ActionDatalabel4.Text = GetPet(thisByte)
                ActionDataLabel4_start = 2
                ActionDataLabel4_len = 1
                SetActionFormat(1, 11, 2, 12, 0, 0, 0, 0, 0, 0, 0, 0, 0)
            Case 37
                Actionlabel1.Text = "Opcode 37: Spawn 1 monster of type"
                Actionlabel2.Text = "within"
                Actionlabel3.Text = "meters of"
                If OpMode = 1 Then
                    monType = FindVal(TBL(1), TBL(0), 0, 0, 2)
                    btPos = FindVal(TBL(2), 0, 0, 0, 1)
                    iDistance = FindVal(TBL(7), TBL(6), TBL(5), TBL(4), 4)
                    thisByte = FindVal(TBL(2), 0, 0, 0, 1)
                Else
                    sVal = 0
                    LoadtempActionBytes("0 0 0 205 0 0 0 0")
                End If
                actiondatalabel1.Text = monType
                ActionDataLabel1_start = 0
                ActionDataLabel1_len = 2
                actiondatalabel2.Text = GetbtPos(btPos)
                ActionDataLabel2_start = 2
                ActionDataLabel2_len = 1
                actiondatalabel3.Text = iDistance
                ActionDataLabel3_start = 4
                ActionDataLabel3_len = 4
                ActionDatalabel4.Text = GetPet(thisByte)
                ActionDataLabel4_start = 2
                ActionDataLabel4_len = 1
                SetActionFormat(1, 11, 2, 13, 3, 12, 14, 0, 0, 0, 0, 0, 0)
        End Select
        t = t
    End Sub
    Private Function GetValFromByteString(S As Integer, L As Integer)
        Dim curVal As Integer
        If L = 1 Then curVal = FindVal(TempCondBytes(S), 0, 0, 0, 1)
        If L = 2 Then curVal = FindVal(TempCondBytes(S + 1), TempCondBytes(S), 0, 0, 2)
        If L = 4 Then curVal = FindVal(TempCondBytes(S + 3), TempCondBytes(S + 2), TempCondBytes(S + 1), TempCondBytes(S), 4)
        GetValFromByteString = curVal
    End Function
    Private Sub CondDatalabel1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CondDatalabel1.Click
        Dim Response As String
        Dim curVal, newval As Integer
        Dim opCode As Long
        curVal = GetValFromByteString(CondDataLabel1_start, CondDataLabel1_len)
        opCode = CLng(CurrentCondOpcode.Text) - 67108865
        If opCode = 1 Then 'switches from given to received
            newval = curVal + 1
            If newval > 1 Then newval = 0
            CondDatalabel1.Text = GiveRec(newval)
        ElseIf opCode = 2 Or opCode = 8 Then 'check isAllied
            newval = curVal + 1
            If newval > 1 Then newval = 0
            CondDatalabel1.Text = IsAllied(newval)
        ElseIf opCode = 4 Or opCode = 6 Or opCode = 10 Or opCode = 11 Then 'check MoreLess
            newval = curVal + 1
            If newval > 1 Then newval = 0
            CondDatalabel1.Text = MoreLess(newval)
        ElseIf opCode = 13 Or opCode = 29 Then 'check target type myself or my target
            newval = curVal + 1
            If newval > 1 Then newval = 0
            CondDatalabel1.Text = GetCheckTarget(newval)
        Else
            Response = InputBox("please enter new value", CondDatalabel1.Text)
            If Response = "" Then
                MsgBox("You must enter a value")
                Exit Sub
            End If
            newval = Val(Response)
            If opCode = 7 Then 'random number must be in the range of 1 to 100
                If newval > 100 Then newval = 100
                If newval < 1 Then newval = 1
                newval = curVal + 1
            End If
            CondDatalabel1.Text = newval
            End If

            TempCondBytes_Insert(newval, CondDataLabel1_start, CondDataLabel1_len)
            FormatCond()
    End Sub
    Private Sub CondDatalabel2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CondDataLabel2.Click
        Dim Response As String
        Dim newVal, curVal As Integer
        Dim OpCode As Long
        curVal = GetValFromByteString(CondDataLabel2_start, CondDataLabel2_len)
        OpCode = CLng(CurrentCondOpcode.Text) - 67108865
        If OpCode = 5 Or OpCode = 10 Or OpCode = 11 Or OpCode = 20 Then 'check abOption
            newVal = curVal + 1
            If newVal > 5 Then newVal = 0
            CondDataLabel2.Text = GetABoption(newVal)
        ElseIf OpCode = 13 Then 'check buff status type
            newVal = curVal + 1
            If newVal > 2 Then newVal = 0
            CondDataLabel2.Text = GetStatusType(newVal)
        ElseIf OpCode = 12 Then
            newVal = curVal + 1
            If newVal > 1 Then newVal = 0
            CondDataLabel2.Text = GetDayNight(newVal)
        ElseIf OpCode = 3 Then 'check stat sOption
            newVal = curVal + 1
            If newVal > 90 Then newVal = 0
            CondDataLabel2.Text = GetSoption(newVal)
        ElseIf OpCode = 5 Then
            newVal = curVal + 1
            If newVal > 1 Then newVal = 0
            CondDataLabel2.Text = GetTF(newVal)
        Else
            Response = InputBox("please enter new value", CondDataLabel2.Text)
            If Response = "" Then
                MsgBox("You must enter a value")
                Exit Sub
            End If
            newVal = Val(Response)
            CondDataLabel2.Text = newVal
        End If
        TempCondBytes_Insert(newVal, CondDataLabel2_start, CondDataLabel2_len)
        FormatCond()
    End Sub
    Private Sub CondDatalabel3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CondDataLabel3.Click
        Dim Response As String
        Dim s, newVal As Integer
        Dim curVal As Integer
        Dim OpCode As Long
        curVal = GetValFromByteString(CondDataLabel3_start, CondDataLabel3_len)
        OpCode = CLng(CurrentCondOpcode.Text) - 67108865
        If OpCode = 5 Then
            newVal = curVal + 1
            If newVal > 1 Then newVal = 0
            CondDataLabel3.Text = GetIS(newVal)
        ElseIf OpCode = 13 Then 'check if present or not
            newVal = curVal + 1
            If newVal > 1 Then newVal = 0
            CondDataLabel3.Text = GetHave(newVal)
        ElseIf OpCode = 9 Then
            newVal = curVal + 1
            If newVal > 1 Then newVal = 0
            CondDataLabel3.Text = GetHasSkill(newVal)
        ElseIf OpCode = 12 Then
            newVal = curVal + 1
            If newVal > 1 Then newVal = 0
            CondDataLabel3.Text = GetNear(newVal)
        Else
            Response = InputBox("please enter new value", CondDataLabel3.Text)
            If Response = "" Then
                MsgBox("You must enter a value")
                Exit Sub
            End If
            newVal = Val(Response)
            CondDataLabel3.Text = newVal
        End If
        TempCondBytes_Insert(newVal, CondDataLabel3_start, CondDataLabel3_len)
        FormatCond()
    End Sub
    Private Sub CondDataLabel4_Click(sender As System.Object, e As System.EventArgs) Handles CondDataLabel4.Click
        Dim Response As String
        Dim s, newVal As Integer
        s = s
        Response = InputBox("please enter new value", CondDataLabel4.Text)
        If Response = "" Then
            MsgBox("You must enter a value")
            Exit Sub
        End If
        newVal = Val(Response)
        CondDataLabel4.Text = newVal
        TempCondBytes_Insert(newVal, CondDataLabel4_start, CondDataLabel4_len)
        FormatCond()
    End Sub
    Private Sub CondDataLabel5_Click(sender As System.Object, e As System.EventArgs) Handles CondDataLabel5.Click
        Dim Response As String
        Dim s, newVal As Integer
        s = s
        Response = InputBox("please enter new value", CondDataLabel5.Text)
        If Response = "" Then
            MsgBox("You must enter a value")
            Exit Sub
        End If
        newVal = Val(Response)
        CondDataLabel5.Text = newVal
        TempCondBytes_Insert(newVal, CondDataLabel5_start, CondDataLabel5_len)
        FormatCond()
    End Sub
    Private Sub CondbtOp1_Click(sender As System.Object, e As System.EventArgs) Handles CondbtOp1.Click
        'Handles standard btOp operations
        Dim btOpVal As Integer
        Dim newval As Integer
        btOpVal = TempCondBytes(CondbtOp1_start)
        newval = btOpVal + 1
        If newval > 10 Then newval = 0
        CondbtOp1.Text = GetbtOp(newval)
        TempCondBytes_Insert(newval, CondbtOp1_start, CondbtOp1_len)
        FormatCond()
    End Sub

    Private Sub SetCondFormat(a As Integer, b As Integer, c As Integer, d As Integer, e As Integer, f As Integer, g As Integer, h As Integer, i As Integer, j As Integer, k As Integer, l As Integer, m As Integer)
        CondFormat(1) = a
        CondFormat(2) = b
        CondFormat(3) = c
        CondFormat(4) = d
        CondFormat(5) = e
        CondFormat(6) = f
        CondFormat(7) = g
        CondFormat(8) = h
        CondFormat(9) = i
        CondFormat(10) = j
        CondFormat(11) = k
        CondFormat(12) = l
        CondFormat(13) = m
        FormatCond()
    End Sub
    Sub FormatAction()
        Dim t, lastAction, thisAction, leftpos As Integer
        Actionlabel1.Visible = True
        For t = 2 To 14
            thisAction = ActionFormat(t)
            If thisAction <> 0 Then
                lastAction = ActionFormat(t - 1)
                Select Case lastAction
                    Case 1
                        leftpos = Actionlabel1.Left + Actionlabel1.Width + 2
                    Case 2
                        leftpos = Actionlabel2.Left + Actionlabel2.Width + 2
                    Case 3
                        leftpos = Actionlabel3.Left + Actionlabel3.Width + 2
                    Case 4
                        leftpos = Actionlabel4.Left + Actionlabel4.Width + 2
                    Case 5
                        leftpos = ActionLabel5.Left + ActionLabel5.Width + 2
                    Case 6
                        leftpos = ActionLabel6.Left + ActionLabel6.Width + 2
                    Case 7
                        leftpos = ActionLabel7.Left + ActionLabel7.Width + 2
                    Case 11
                        leftpos = actiondatalabel1.Left + actiondatalabel1.Width + 2
                    Case 12
                        leftpos = actiondatalabel2.Left + actiondatalabel2.Width + 2
                    Case 13
                        leftpos = actiondatalabel3.Left + actiondatalabel3.Width + 2
                    Case 14
                        leftpos = ActionDatalabel4.Left + ActionDatalabel4.Width + 2
                    Case 15
                        leftpos = ActionDatalabel5.Left + ActionDatalabel5.Width + 2
                    Case 16
                        leftpos = ActionDataLabel6.Left + ActionDataLabel6.Width + 2
                    Case 17
                        leftpos = ActionDataLabel7.Left + ActionDataLabel7.Width + 2
                    Case 21
                        leftpos = actionTF1.Left + actionTF1.Width + 2
                    Case 23
                        leftpos = actionAS1.Left + actionAS1.Width + 2
                    Case 24
                        leftpos = ActionSOption1.Left + ActionSOption1.Width + 2
                    Case 25
                        leftpos = ActionQOption1.Left + ActionQOption1.Width + 2
                    Case 31
                        leftpos = ActionbtOp1.Left + ActionbtOp1.Width + 2
                    Case 32
                        leftpos = actioncombo2.Left + actioncombo2.Width + 2
                    Case 32
                        leftpos = ActionCombo4.Left + ActionCombo4.Width + 2
                    Case 41
                        leftpos = actionoption1.Left + actionoption1.Width + 2
                End Select
                Select Case thisAction
                    Case 2
                        Actionlabel2.Left = leftpos
                        Actionlabel2.Visible = True
                    Case 3
                        Actionlabel3.Left = leftpos
                        Actionlabel3.Visible = True
                    Case 4
                        Actionlabel4.Left = leftpos
                        Actionlabel4.Visible = True
                    Case 5
                        ActionLabel5.Left = leftpos
                        ActionLabel5.Visible = True
                    Case 6
                        ActionLabel6.Left = leftpos
                        ActionLabel6.Visible = True
                    Case 7
                        ActionLabel7.Left = leftpos
                        ActionLabel7.Visible = True
                    Case 11
                        actiondatalabel1.Left = leftpos
                        actiondatalabel1.Visible = True
                    Case 12
                        actiondatalabel2.Left = leftpos
                        actiondatalabel2.Visible = True
                    Case 13
                        actiondatalabel3.Left = leftpos
                        actiondatalabel3.Visible = True
                    Case 14
                        ActionDatalabel4.Left = leftpos
                        ActionDatalabel4.Visible = True
                    Case 15
                        ActionDatalabel5.Left = leftpos
                        ActionDatalabel5.Visible = True
                    Case 16
                        ActionDataLabel6.Left = leftpos
                        ActionDataLabel6.Visible = True
                    Case 17
                        ActionDataLabel7.Left = leftpos
                        ActionDataLabel7.Visible = True
                    Case 21
                        actionTF1.Left = leftpos
                        actionTF1.Visible = True
                    Case 22
                        'ActionTF2.left = leftpos
                    Case 23
                        actionAS1.Left = leftpos
                        actionAS1.Visible = True
                    Case 24
                        ActionSOption1.Left = leftpos
                        ActionSOption1.Visible = True
                    Case 25
                        ActionQOption1.Left = leftpos
                        ActionQOption1.Visible = True
                    Case 31
                        ActionbtOp1.Left = leftpos
                        ActionbtOp1.Visible = True
                    Case 32
                        actioncombo2.Left = leftpos
                        actioncombo2.Visible = True
                    Case 33
                        ActionCombo4.Left = leftpos
                        ActionCombo4.Visible = True
                    Case 41
                        actionoption1.Left = leftpos
                        actionoption1.Visible = True

                End Select
            End If
        Next
    End Sub
    Private Sub SetActionFormat(a As Integer, b As Integer, c As Integer, d As Integer, e As Integer, f As Integer, g As Integer, ByVal h As Integer, i As Integer, j As Integer, k As Integer, l As Integer, m As Integer)
        ActionFormat(1) = a
        ActionFormat(2) = b
        ActionFormat(3) = c
        ActionFormat(4) = d
        ActionFormat(5) = e
        ActionFormat(6) = f
        ActionFormat(7) = g
        ActionFormat(8) = h
        ActionFormat(9) = i
        ActionFormat(10) = j
        ActionFormat(11) = k
        ActionFormat(12) = l
        ActionFormat(13) = m
        FormatAction()
    End Sub
    Private Sub ClearCondFormat()
        Dim t As Integer
        For t = 1 To 8
            CondFormat(t) = 0
        Next
    End Sub
    Private Sub LoadCondCombo1()
        Dim t As Integer
        condedit.ComboBox1.Items.Clear()
        For t = 1 To 100
            condedit.ComboBox1.Items.Add(GetSoption(t))
        Next
    End Sub
    Private Sub LoadActionCombo1()
        Dim t As Integer
        condedit.ComboBox1.Items.Clear()
        For t = 1 To 100
            condedit.ComboBox1.Items.Add(GetSoption(t))
        Next
    End Sub
    Private Sub LoadActionCombo4()
        Dim t As Integer
        condedit.ComboBox1.Items.Clear()
        For t = 1 To 6
            condedit.ComboBox1.Items.Add(GetSelectOptions(t))
        Next
    End Sub
    Private Sub LoadCondCombo2()
        Dim t As Integer
        CondCombo2.Items.Clear()
        For t = 1 To 11
            CondCombo2.Items.Add(GetbtOp(t - 1))
            t = t
        Next
    End Sub
    Function GiveRec(val As Byte) As String
        If val = 0 Then
            GiveRec = "Received"
        Else
            GiveRec = "Inflicted"
        End If
    End Function
    Function IsAllied(val As Byte) As String
        If val = 0 Then
            IsAllied = "Enemies"
        Else
            IsAllied = "Allies"
        End If
    End Function
    Function MoreLess(val As Byte) As String
        If val = 0 Then
            MoreLess = "Greater than"
        Else
            MoreLess = "Less than"
        End If
    End Function

    Private Sub condTF1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles condTF1.Click
        Dim NewVal As Integer
        If condTF1.Text = "IS" Then
            condTF1.Text = "IS NOT"
            NewVal = 0
        Else
            condTF1.Text = "IS"
            NewVal = 1
        End If
        TempCondBytes_Insert(NewVal, CondTF1_start, CondTF1_len)
        FormatCond()
    End Sub
    Function GetISNOT(val As Integer) As String
        GetISNOT = "Undefined"
        If val = 0 Then GetISNOT = "IS NOT"
        If val = 1 Then GetISNOT = "IS"
    End Function
    Private Function GetRwType(eqType As Integer) As String
        GetRwType = "UnDefined"
        Select Case eqType
            Case 0
                GetRwType = "Exp"
            Case 1
                GetRwType = "Zuly"
            Case 2
                GetRwType = "Item with s/n "
            Case 3  'only applicable in custom servers such as KTRose pre-evo or Version 137
                GetRwType = "Buff with skill id "
        End Select
    End Function
    Private Function GetActionName(StartPos As Integer, NameLen As Integer) As String
        Dim t As Integer
        GetActionName = ""
        For t = StartPos To StartPos + NameLen
            If TempActionBytes(t) = 0 Then
                Exit For
            End If
            GetActionName = GetActionName + Chr(TempActionBytes(t))
            t = t
        Next
        t = t
    End Function

    Private Sub condoption1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles condoption1.Click
        Dim a As String
        a = condoption1.Text
        Select Case a
            Case " != "
                condoption1.Text = " = "
            Case " = "
                condoption1.Text = " > "
            Case " > "
                condoption1.Text = " >= "
            Case " >= "
                condoption1.Text = " < "
            Case " < "
                condoption1.Text = " <= "
            Case " <= "
                condoption1.Text = " Set value to "
            Case " Set value to "
                condoption1.Text = " Add value "
            Case " Add value "
                condoption1.Text = " Subtract value "
            Case " Subtract value "
                condoption1.Text = " Increment "
            Case " Increment "
                condoption1.Text = " != "
        End Select
        FormatCond()
    End Sub


    Private Sub condcombo1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles condcombo1.Click
        'Handles standard btOp operations
        LoadCondCombo1()
        condedit.ComboBox1.Visible = True
        condedit.Show()
        FormatCond()
    End Sub
    Private Sub ActionbtOp1_Click(ByVal sender As System.Object, e As System.EventArgs) Handles ActionbtOp1.Click
        'Handles standard btOp operations
        Dim btOpVal As Integer
        Dim newval As Integer
        btOpVal = TempActionBytes(ActionbtOp1_start)
        newval = btOpVal + 1
        If newval > 10 Then newval = 0
        ActionbtOp1.Text = GetbtOp(newval)
        'ActionbtOp1.Text = newval
        TempActionBytes_Insert(newval, ActionbtOp1_start, ActionbtOp1_len)
        FormatAction()
    End Sub
    Private Function GetSelectOptions(t As Integer) As String
        GetSelectOptions = "Un-Defined quest option"
        Select Case t
            Case 0
                GetSelectOptions = "Remove Quest"
            Case 1
                GetSelectOptions = "Start Quest"
            Case 2
                GetSelectOptions = "Replace Quest and keep items"
            Case 3
                GetSelectOptions = "Replace Quest and delete items"
            Case 4
                GetSelectOptions = "Select Quest"
        End Select
    End Function
    Private Function GetLearnSkill(val As Integer) As String
        GetLearnSkill = "Un-Defined choice"
        If val = 0 Then GetLearnSkill = "UnLearn Skill"
        If val = 1 Then GetLearnSkill = "Learn Skill"
    End Function
    Private Function GetAddSub(t As Integer) As String
        GetAddSub = "unknown action " + CStr(t)
        If t = 0 Then GetAddSub = "subtract"
        If t = 1 Then GetAddSub = "add"
    End Function
    Private Function GetSpeechOption(Val As Integer) As String
        GetSpeechOption = "Un-Defined"
        If Val = 0 Then GetSpeechOption = "Whisper to player"
        If Val = 1 Then GetSpeechOption = "Shout to map"
        If Val = 2 Then GetSpeechOption = "Anounce to server"
    End Function
    Private Function GetbtPos(val As Integer) As String
        GetbtPos = "Un-Defined"
        If val = 0 Then GetbtPos = "my Current position"
        If val = 1 Then GetbtPos = "my Attacker's position"
        If val = 2 Then GetbtPos = "my Target's position"
    End Function
    Private Function GetbtTarget(val As Integer) As String
        GetbtTarget = "Un-Defined"
        If val = 0 Then GetbtTarget = "an AOE"
        If val = 1 Then GetbtTarget = "a Targetted"
        If val = 2 Then GetbtTarget = "a Self Targetted"
    End Function
    Private Function GetMsgType(val As Integer) As String
        GetMsgType = "Un-Defined"
        If val = 0 Then GetMsgType = "Say"
        If val = 1 Then GetMsgType = "Shout"
        If val = 2 Then GetMsgType = "Announce"
    End Function
    Private Function GetnMotion(val As Integer) As String
        GetnMotion = "Un-Defined"
        If val = 6 Then GetnMotion = "Buff"
        If val = 8 Then GetnMotion = "Attack"
    End Function
    Private Function GetPet(val As Integer) As String
        GetPet = "without an owner"
        If val = 1 Then GetPet = "as a summon owned by me"
    End Function
    Private Function GetTF(val As Integer) As String
        GetTF = "FALSE"
        If val = 1 Then GetTF = "TRUE"
    End Function
    Private Function GetOnOff(val As Integer) As String
        GetOnOff = "OFF"
        If val = 1 Then GetOnOff = "ON"
    End Function
    Private Function GetIS(val As Integer)
        GetIS = "IS NOT"
        If val = 1 Then GetIS = "IS"
    End Function
    Private Function GetSpawnState(val As Integer) As String
        GetSpawnState = "Despawn"
        If val = 1 Then GetSpawnState = "Spawn"
    End Function
    Private Function GetStance(val As Integer) As String
        GetStance = "Walk"
        If val <> 0 Then GetStance = "Run"
    End Function
    Private Function GetHighLow(val As Integer) As String
        GetHighLow = "Lowest"
        If val <> 0 Then GetHighLow = "Highest"
    End Function
    Private Function GetValFromActionByteString(S As Integer, L As Integer)
        Dim curVal As Integer
        If L = 1 Then curVal = FindVal(TempActionBytes(S), 0, 0, 0, 1)
        If L = 2 Then curVal = FindVal(TempActionBytes(S + 1), TempActionBytes(S), 0, 0, 2)
        If L = 4 Then curVal = FindVal(TempActionBytes(S + 3), TempActionBytes(S + 2), TempActionBytes(S + 1), TempActionBytes(S), 4)
        GetValFromActionByteString = curVal
    End Function

    Private Sub ActionCombo4_Click(sender As System.Object, e As System.EventArgs) Handles ActionCombo4.Click
        Dim t As Integer
        If ActionCombo4.Text = "Remove Quest" Then t = 0
        If ActionCombo4.Text = "Start Quest" Then t = 1
        If ActionCombo4.Text = "Replace Quest and keep items" Then t = 2
        If ActionCombo4.Text = "Replace Quest and delete items" Then t = 3
        If ActionCombo4.Text = "Select Quest" Then t = 4
        t = t + 1
        If t > 4 Then t = 0
        ActionCombo4.Text = GetSelectOptions(t)
        FormatAction()
        TempActionBytes_Insert(t, ActionCombo4_start, ActionCombo4_len)
        'DisplayCurrentActionBytes()
    End Sub

    Private Sub actiondatalabel1_Click(sender As System.Object, e As System.EventArgs) Handles actiondatalabel1.Click
        Dim Response, CurrentValue As String
        Dim newval, curVal As Integer
        Dim opCode As Long
        Dim S, l As Integer
        Dim a, t, ThisLen As Integer
        CurrentValue = actiondatalabel1.Text
        S = ActionDataLabel1_start
        l = ActionDataLabel1_len
        If l = 1 Then curVal = FindVal(TempActionBytes(S), 0, 0, 0, 1)
        If l = 2 Then curVal = FindVal(TempActionBytes(S + 1), TempActionBytes(S), 0, 0, 2)
        If l = 4 Then curVal = FindVal(TempActionBytes(S + 3), TempActionBytes(S + 2), TempActionBytes(S + 1), TempActionBytes(S), 4)
        opCode = CLng(CurrentActionOpcode.Text) - 184549377
        If opCode = 3 Or opCode = 4 Or opCode = 5 Or opCode = 8 Then 'move speed options
            newval = curVal + 1
            If newval > 1 Then newval = 0
            actiondatalabel1.Text = GetStance(newval)
            TempActionBytes_Insert(newval, ActionDataLabel1_start, ActionDataLabel1_len)
            FormatAction()
            Exit Sub
        End If
        If opCode = 6 Then 'Ability options
            newval = curVal + 1
            If newval > 7 Then newval = 0
            actiondatalabel1.Text = GetABoption(newval)
            TempActionBytes_Insert(newval, ActionDataLabel1_start, ActionDataLabel1_len)
            FormatAction()
            Exit Sub
        End If
        If opCode = 28 Then 'message type
            newval = curVal + 1
            If newval > 2 Then newval = 0
            actiondatalabel1.Text = GetMsgType(newval)
            TempActionBytes_Insert(newval, ActionDataLabel1_start, ActionDataLabel1_len)
            FormatAction()
            Exit Sub
        End If

        Response = InputBox("please enter new value", "Current value " + CStr(CurrentValue))
        If Response = "" Then Exit Sub
        If opCode = 30 Then 'entry is a quest trigger
            'For t = 0 To 50
            'TempActionBytes(t) = 0
            'Next
            actiondatalabel1.Text = Response
            ThisLen = Len(Response)
            For t = 1 To ThisLen
                TempActionBytes_Insert(Asc(Mid(Response, t, 1)), t + 1, 1)
            Next

            ThisLen = ThisLen + 1
            TempActionBytes_Insert(ThisLen, 0, 2)
            'ActionDataLabel1_start = 2
            'TempActionByteCount = t + 2
            FormatAction()
            DisplayCurrentActionBytes()
            Exit Sub
        End If
        On Error GoTo bypass
        If Response <> "" Then

            newval = Val(Response)
            actiondatalabel1.Text = newval
            If opCode = 16777223 Or opCode = 16777224 Then 'map id
                actiondatalabel1.Text = GetMap(newval)
            End If

            TempActionBytes_Insert(newval, ActionDataLabel1_start, ActionDataLabel1_len)
            FormatAction()
        End If
        a = a

bypass:
    End Sub
    Private Sub actiondatalabel2_Click(sender As System.Object, e As System.EventArgs) Handles actiondatalabel2.Click
        Dim Response As String
        Dim newval, curVal As Integer
        Dim opCode As Long
        Dim StrLen, t As Integer
        Dim tmpString As String
        Dim S, l As Integer
        Dim a, iHash As Integer
        S = ActionDataLabel2_start
        l = ActionDataLabel2_len
        If l = 1 Then curVal = FindVal(TempActionBytes(S), 0, 0, 0, 1)
        If l = 2 Then curVal = FindVal(TempActionBytes(S + 1), TempActionBytes(S), 0, 0, 2)
        If l = 4 Then curVal = FindVal(TempActionBytes(S + 3), TempActionBytes(S + 2), TempActionBytes(S + 1), TempActionBytes(S), 4)
        opCode = CLng(CurrentActionOpcode.Text) - 184549377
        If opCode = 6 Then 'high or low
            newval = curVal + 1
            If newval > 1 Then newval = 0
            actiondatalabel2.Text = GetHighLow(newval)
            TempActionBytes_Insert(newval, ActionDataLabel2_start, ActionDataLabel2_len)
            FormatAction()
            Exit Sub
        End If
        If opCode = 20 Or opCode = 37 Then 'position
            newval = curVal + 1
            If newval > 2 Then newval = 0
            actiondatalabel2.Text = GetbtPos(newval)
            TempActionBytes_Insert(newval, ActionDataLabel2_start, ActionDataLabel2_len)
            FormatAction()
            Exit Sub
        End If
        If opCode = 24 Then 'skill type
            newval = curVal + 1
            If newval > 2 Then newval = 0
            actiondatalabel2.Text = GetbtTarget(newval)
            TempActionBytes_Insert(newval, ActionDataLabel2_start, ActionDataLabel2_len)
            FormatAction()
            Exit Sub
        End If
        If opCode = 32 Then 'toggle pvp
            newval = curVal + 1
            If newval > 1 Then newval = 0
            actiondatalabel2.Text = Getonoff(newval)
            TempActionBytes_Insert(newval, ActionDataLabel2_start, ActionDataLabel2_len)
            FormatAction()
            Exit Sub
        End If
        
        Response = InputBox("please enter new value", "Current value " + actiondatalabel2.Text)
        'On Error GoTo bypass
        If Response <> "" Then
            opCode = CLng(CurrentActionOpcode.Text)
            newval = Val(Response)
            actiondatalabel2.Text = newval

            If opCode = 16777225 Or opCode = 16777229 Or opCode = 16777234 Or opCode = 16777245 Then 'Expects a string to be returned from actiondatalabel2
                StrLen = Len(Response)
                'clear tempactionbytes and rebuild it
                'For t = 0 To 100
                'TempActionBytes(t) = 0
                ' Next
                TempActionBytes(ActionDataLabel4_start) = StrLen + 1 'need to put the namelen start point in here even though we don't use this label
                actiondatalabel2.Text = Response
                Actionlabel2.Text = "String length: " + CStr(StrLen + 1)
                t = t
                For t = 1 To StrLen
                    tmpString = Mid(Response, t, 1)
                    TempActionBytes(t + ActionDataLabel2_start - 1) = Asc(tmpString)

                Next
                TempActionBytes(StrLen + ActionDataLabel2_start) = 0
                If opCode = 16777225 Or opCode = 16777245 Then
                    TempActionBytes(StrLen + 1 + ActionDataLabel2_start) = 205
                Else
                    TempActionBytes(StrLen + 1 + ActionDataLabel2_start) = 0
                End If
                TempActionByteCount = StrLen + 1 + ActionDataLabel2_start
                FormatAction()
                DisplayCurrentActionBytes()
                Exit Sub
            End If

            FormatAction()
        End If
        TempActionBytes_Insert(newval, ActionDataLabel2_start, ActionDataLabel2_len)
bypass:
    End Sub
    Private Sub actiondatalabel3_Click(sender As System.Object, e As System.EventArgs) Handles actiondatalabel3.Click
        Dim Response As String
        Dim newVal, curVal As Integer
        Dim NewFloat As Single
        Dim opCode As Long
        Dim S, l As Integer
        Dim a, iHash As Integer
        S = ActionDataLabel3_start
        l = ActionDataLabel3_len
        If l = 1 Then curVal = FindVal(TempActionBytes(S), 0, 0, 0, 1)
        If l = 2 Then curVal = FindVal(TempActionBytes(S + 1), TempActionBytes(S), 0, 0, 2)
        If l = 4 Then curVal = FindVal(TempActionBytes(S + 3), TempActionBytes(S + 2), TempActionBytes(S + 1), TempActionBytes(S), 4)
        opCode = CLng(CurrentActionOpcode.Text) - 184549377
        If opCode = 24 Then 'skill type
            newVal = curVal + 1
            If newVal > 8 Then newVal = 0
            actiondatalabel3.Text = GetnMotion(newVal)
            TempActionBytes_Insert(newVal, ActionDataLabel3_start, ActionDataLabel3_len)
            FormatAction()
            Exit Sub
        End If
        Response = InputBox("please enter new value", "Current value " + actiondatalabel3.Text)
        On Error GoTo bypass
        If Response <> "" Then
            opCode = CLng(CurrentActionOpcode.Text)
            newval = Val(Response)
            actiondatalabel3.Text = newval
            If opCode = 16777223 Or opCode = 16777224 Or opCode = 16777237 Then 'map Y coord
                NewFloat = CSng(Response)
                actiondatalabel3.Text = NewFloat
                newval = NewFloat * 100
                a = a
            End If
            FormatAction()
        End If
        TempActionBytes_Insert(newval, ActionDataLabel3_start, ActionDataLabel3_len)
bypass:
    End Sub
    Private Sub ActionDatalabel4_Click(sender As System.Object, e As System.EventArgs) Handles ActionDatalabel4.Click
        Dim Response As String
        Dim newval, curVal As Integer
        Dim opCode As Long
        Dim S, l As Integer
        Dim a, iHash As Integer
        S = ActionDataLabel4_start
        l = ActionDataLabel4_len
        If l = 1 Then curVal = FindVal(TempActionBytes(S), 0, 0, 0, 1)
        If l = 2 Then curVal = FindVal(TempActionBytes(S + 1), TempActionBytes(S), 0, 0, 2)
        If l = 4 Then curVal = FindVal(TempActionBytes(S + 3), TempActionBytes(S + 2), TempActionBytes(S + 1), TempActionBytes(S), 4)
        opCode = CLng(CurrentActionOpcode.Text) - 184549377
        If opCode = 36 Or opCode = 37 Then 'is it a pet?
            newval = curVal + 1
            If newval > 1 Then newval = 0
            ActionDatalabel4.Text = GetPet(newval)
            TempActionBytes_Insert(newval, ActionDataLabel4_start, ActionDataLabel4_len)
            FormatAction()
            Exit Sub
        End If
        Response = InputBox("please enter new value", "Current value " + ActionDatalabel4.Text)
        On Error GoTo bypass
        If Response <> "" Then
            newval = Val(Response)
            ActionDatalabel4.Text = newval
            FormatAction()
        End If
        TempActionBytes_Insert(newval, ActionDataLabel4_start, ActionDataLabel4_len)
bypass:
    End Sub
    Private Sub ActionDatalabel5_Click(sender As System.Object, e As System.EventArgs) Handles ActionDatalabel5.Click
        Dim Response As String
        Dim newval As Integer
        Response = InputBox("please enter new value", "Current value " + ActionDatalabel5.Text)
        On Error GoTo bypass
        If Response <> "" Then
            newval = Val(Response)
            ActionDatalabel5.Text = newval
            FormatAction()
        End If
        TempActionBytes_Insert(newval, ActionDataLabel5_start, ActionDataLabel5_len)
bypass:
    End Sub
    Private Sub ActionDataLabel6_Click(sender As System.Object, e As System.EventArgs) Handles ActionDataLabel6.Click
        Dim Response As String
        Dim newval As Integer
        Response = InputBox("please enter new value", "Current value " + ActionDataLabel6.Text)
        On Error GoTo bypass
        If Response <> "" Then
            newval = Val(Response)
            ActionDataLabel6.Text = newval
            FormatAction()
        End If
        TempActionBytes_Insert(newval, ActionDataLabel6_start, ActionDataLabel6_len)
bypass:
    End Sub
    Private Sub ActionDataLabel7_Click(sender As System.Object, e As System.EventArgs) Handles ActionDataLabel7.Click
        Dim Response As String
        Dim newval As Integer
        Response = InputBox("please enter new value", "Current value " + ActionDataLabel7.Text)
        On Error GoTo bypass
        If Response <> "" Then
            newval = Val(Response)
            ActionDataLabel7.Text = newval
            FormatAction()
        End If
        TempActionBytes_Insert(newval, ActionDataLabel7_start, ActionDataLabel7_len)
bypass:
    End Sub
    Private Sub actionAS1_Click(sender As System.Object, e As System.EventArgs) Handles actionAS1.Click
        Dim newval As Integer
        If actionAS1.Text = "Add" Then
            actionAS1.Text = "Subtract"
            newval = 0
        Else
            actionAS1.Text = "Add"
            newval = 1
        End If
        TempActionBytes_Insert(newval, ActionAS1_start, ActionAS1_len)
    End Sub
    Private Sub ActionSOption1_Click(sender As System.Object, e As System.EventArgs) Handles ActionSOption1.Click
        Dim Response As String
        Dim newval As Integer
        Dim OldVal As Integer
        OldVal = TempActionBytes(ActionSOption1_start) 'only needs one byte despite the fact that sOption reads 4. very strange
        'scroll through possible values
        newval = OldVal + 1
        Response = GetSoption(newval)
        While Response = "invalid"
            newval += 1
            If newval > 100 Then newval = 0
            Response = GetSoption(newval)
        End While
        newval = Val(Response)
        ActionSOption1.Text = GetSoption(newval)
        TempActionBytes_Insert(newval, ActionSOption1_start, ActionSOption1_len)
        FormatAction()
    End Sub
    Private Sub actionoption1_Click(sender As System.Object, e As System.EventArgs) Handles actionoption1.Click
        'this one handles a few different options
        Dim OpCode As Long
        Dim rwdType As Integer
        OpCode = CLng(CurrentActionOpcode.Text)
        If OpCode = 16777221 Then
            rwdType = TempActionBytes(0) + 1
            If rwdType > 3 Then rwdType = 0
            actionoption1.Text = GetRwType(rwdType)
            TempActionBytes_Insert(rwdType, ActionOption1_start, ActionOption1_len)
        End If
        FormatAction()
    End Sub
    Private Sub actionTF1_Click(sender As System.Object, e As System.EventArgs) Handles actionTF1.Click
        Dim curVal As Integer
        Dim NewVal As Integer
        Dim OpCode As Long
        Dim S, l As Integer
        S = ActionDataLabel2_start
        l = ActionDataLabel2_len
        If l = 1 Then curVal = FindVal(TempActionBytes(S), 0, 0, 0, 1)
        If l = 2 Then curVal = FindVal(TempActionBytes(S + 1), TempActionBytes(S), 0, 0, 2)
        If l = 4 Then curVal = FindVal(TempActionBytes(S + 3), TempActionBytes(S + 2), TempActionBytes(S + 1), TempActionBytes(S), 4)
        OpCode = CLng(CurrentActionOpcode.Text) - 184549377
        curVal = TempActionBytes(ActionTF1_start)
        NewVal = curVal + 1
        If NewVal > 1 Then NewVal = 0
        If OpCode = 17 Then
            actionTF1.Text = GetTF(NewVal)
        End If
        TempActionBytes_Insert(NewVal, ActionTF1_start, ActionTF1_len)
        FormatAction()
    End Sub
    Private Sub ActionQOption1_Click(sender As System.Object, e As System.EventArgs) Handles ActionQOption1.Click
        Dim curVal As Integer
        Dim NewVal As Integer
        Dim OpCode As Long
        OpCode = CLng(CurrentActionOpcode.Text)
        curVal = GetValFromActionByteString(ActionQOption1_start, ActionQOption1_len)
        NewVal = curVal + 16
        If NewVal > 100 Then NewVal = 0
        ActionQOption1.Text = GetVarType(NewVal)
        TempActionBytes_Insert(NewVal, ActionQOption1_start, ActionQOption1_len)
        NewVal = NewVal
        FormatAction()
    End Sub


    Private Sub TempActionBytes_Insert(value As Long, position As Integer, NumBytes As Integer)
        'Convert values to bytes and puts them into the TempActionBytes array
        Dim a As Integer
        Dim TempHex As String
        Dim CountO As Integer
        Dim TempByteStr(4) As String
        Dim TempByte(4) As Byte
        Dim tempInt(4) As Integer
        Dim ByteIndex As Integer
        ByteIndex = 1
        TempHex = Hex(value)
        If NumBytes = 1 Then
            If value > 255 Then
                MsgBox("the value you have entered is too large for one byte")
                Exit Sub
            End If
            value = CByte(value)
            TempActionBytes(position) = value
            a = a
        End If
        If NumBytes = 2 Then
            If value > 65535 Then
                MsgBox("the value you have entered is too large for two bytes")
                Exit Sub
            End If
            If Len(TempHex) < 4 Then
                CountO = 4 - Len(TempHex)
                For a = 1 To CountO
                    TempHex = "0" + TempHex
                Next
            End If
            TempByte(1) = CByte("&H" + Mid(TempHex, Len(TempHex) - 1, 1) + Mid(TempHex, Len(TempHex), 1))
            TempByte(2) = CByte("&H" + Mid(TempHex, Len(TempHex) - 3, 1) + Mid(TempHex, Len(TempHex) - 2, 1))
            TempActionBytes(position) = TempByte(1)
            TempActionBytes(position + 1) = TempByte(2)
            a = a
        End If
        If NumBytes = 4 Then
            If value > 4294967295 Then
                MsgBox("the value you have entered is too large for 4 bytes")
                Exit Sub
            End If
            If Len(TempHex) < 8 Then
                CountO = 8 - Len(TempHex)
                For a = 1 To CountO
                    TempHex = "0" + TempHex
                Next
            End If
            TempByte(1) = CByte("&H" + Mid(TempHex, Len(TempHex) - 1, 1) + Mid(TempHex, Len(TempHex), 1))
            TempByte(2) = CByte("&H" + Mid(TempHex, Len(TempHex) - 3, 1) + Mid(TempHex, Len(TempHex) - 2, 1))
            TempByte(3) = CByte("&H" + Mid(TempHex, Len(TempHex) - 5, 1) + Mid(TempHex, Len(TempHex) - 4, 1))
            TempByte(4) = CByte("&H" + Mid(TempHex, Len(TempHex) - 7, 1) + Mid(TempHex, Len(TempHex) - 6, 1))
            TempActionBytes(position) = TempByte(1)
            TempActionBytes(position + 1) = TempByte(2)
            TempActionBytes(position + 2) = TempByte(3)
            TempActionBytes(position + 3) = TempByte(4)

            a = a
        End If
        DisplayCurrentActionBytes()
        a = a
    End Sub
    Private Sub TempCondBytes_Insert(value As Long, position As Integer, NumBytes As Integer)
        'Convert values to bytes and puts them into the TempActionBytes array
        Dim a As Integer
        Dim TempHex As String
        Dim CountO As Integer
        Dim TempByteStr(4) As String
        Dim TempByte(4) As Byte
        Dim tempInt(4) As Integer
        Dim ByteIndex As Integer
        ByteIndex = 1
        TempHex = Hex(value)
        If NumBytes = 1 Then
            If value > 255 Then
                MsgBox("the value you have entered is too large for one byte")
                Exit Sub
            End If
            value = CByte(value)
            TempCondBytes(position) = value
            a = a
        End If
        If NumBytes = 2 Then
            If value > 65535 Then
                MsgBox("the value you have entered is too large for two bytes")
                Exit Sub
            End If
            If Len(TempHex) < 4 Then
                CountO = 4 - Len(TempHex)
                For a = 1 To CountO
                    TempHex = "0" + TempHex
                Next
            End If
            TempByte(1) = CByte("&H" + Mid(TempHex, Len(TempHex) - 1, 1) + Mid(TempHex, Len(TempHex), 1))
            TempByte(2) = CByte("&H" + Mid(TempHex, Len(TempHex) - 3, 1) + Mid(TempHex, Len(TempHex) - 2, 1))
            TempCondBytes(position) = TempByte(1)
            TempCondBytes(position + 1) = TempByte(2)
            a = a
        End If
        If NumBytes = 4 Then
            If value > 4294967295 Then
                MsgBox("the value you have entered is too large for 4 bytes")
                Exit Sub
            End If
            If Len(TempHex) < 8 Then
                CountO = 8 - Len(TempHex)
                For a = 1 To CountO
                    TempHex = "0" + TempHex
                Next
            End If
            TempByte(1) = CByte("&H" + Mid(TempHex, Len(TempHex) - 1, 1) + Mid(TempHex, Len(TempHex), 1))
            TempByte(2) = CByte("&H" + Mid(TempHex, Len(TempHex) - 3, 1) + Mid(TempHex, Len(TempHex) - 2, 1))
            TempByte(3) = CByte("&H" + Mid(TempHex, Len(TempHex) - 5, 1) + Mid(TempHex, Len(TempHex) - 4, 1))
            TempByte(4) = CByte("&H" + Mid(TempHex, Len(TempHex) - 7, 1) + Mid(TempHex, Len(TempHex) - 6, 1))
            TempCondBytes(position) = TempByte(1)
            TempCondBytes(position + 1) = TempByte(2)
            TempCondBytes(position + 2) = TempByte(3)
            TempCondBytes(position + 3) = TempByte(4)

            a = a
        End If
        DisplayCurrentCondBytes()
        a = a
    End Sub


    Private Sub Button7_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button7.Click
        'copies the byte string into the TempCondBytes structure
        'allows direct editing of the byte string this way
        Dim ThisSplit
        Dim ThisString, byteStr As String
        Dim ByteCount, t As Integer
        Dim tempByte As Byte
        ThisString = CurrentCondByteString.Text

        ThisSplit = Split(ThisString, " ", -1)
        ByteCount = UBound(ThisSplit)
        For t = 0 To 100
            If t < ByteCount Then
                byteStr = ThisSplit(t)
                If RadioButton1.Checked = True Then 'convert hex values to real numbers
                    byteStr = "&H" + byteStr
                End If
                tempByte = Val(byteStr)
                TempCondBytes(t) = tempByte
            Else
                TempCondBytes(t) = 0
            End If
        Next
        'DisplayCurrentCondBytes()
        OpMode = 1
        DispCondData()
    End Sub
    Private Sub Button11_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button11.Click
        'copies the byte string into the TempActionBytes structure
        'allows direct editing of the byte string this way
        Dim ThisSplit
        Dim ThisString, byteStr As String
        Dim ByteCount, t As Integer
        Dim tempByte As Byte
        ThisString = CurrentActionByteString.Text
        ThisSplit = Split(ThisString, " ", -1)
        ByteCount = UBound(ThisSplit)
        For t = 0 To 100
            If t < ByteCount Then
                byteStr = ThisSplit(t)
                If RadioButton1.Checked = True Then 'convert hex values to real numbers
                    byteStr = "&H" + byteStr
                End If
                tempByte = Val(byteStr)
                TempActionBytes(t) = tempByte
            Else
                TempActionBytes(t) = 0
            End If
        Next
        ' DisplayCurrentActionBytes()
        OpMode = 1
        DispActionData()
    End Sub

    Private Sub RadioButton1_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles RadioButton1.CheckedChanged
        DisplayCurrentCondBytes()
        DisplayCurrentActionBytes()
    End Sub

    Private Sub RadioButton2_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles RadioButton2.CheckedChanged
        DisplayCurrentCondBytes()
        DisplayCurrentActionBytes()
    End Sub


    Private Sub CondDataCount_Click(sender As System.Object, e As System.EventArgs) Handles CondDataCount.Click
        Dim curVal, newVal, maxVal As Integer
        maxVal = Val(CondDatalabel1.Text)
        curVal = Val(CondDataCount.Text)
        newVal = curVal + 1
        If newVal > maxVal Then newVal = 1
        CondDataCount.Text = newVal
        newVal = newVal
        DispCondData()
    End Sub

    Private Sub ActionDataCount_Click(sender As System.Object, e As System.EventArgs) Handles ActionDataCount.Click
        Dim curVal, newVal, maxVal As Integer
        maxVal = Val(actiondatalabel3.Text)
        curVal = Val(ActionDataCount.Text)
        newVal = curVal + 1
        If newVal > maxVal Then newVal = 1
        ActionDataCount.Text = newVal
        newVal = newVal
        DispActionData()
    End Sub
End Class
