Public Class Opcodes


    Private Sub Opcodes_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim a As Integer
        Dim testmode As Integer
        OpCodesList.Items.Clear()
        testmode = Form1.OpMode
        a = a
        If Form1.OpMode = 1 Then
            OpCodesList.Items.Add("0  : Check Quest. Returns TRUE if the player has this quest.")
            OpCodesList.Items.Add("1  : Check Quest Variable.")
            OpCodesList.Items.Add("2  : Check Quest variable. (same as 1)")
            OpCodesList.Items.Add("3  : Check Stats.")
            OpCodesList.Items.Add("4  : Check items.")
            OpCodesList.Items.Add("5  : Check Party.")
            OpCodesList.Items.Add("6  : Check position. TRUE if within distance A of specified location.")
            OpCodesList.Items.Add("7  : Check World Time. TRUE if between time A and time B.")
            OpCodesList.Items.Add("8  : Check Quest Timer.")
            OpCodesList.Items.Add("9  : Check Skills.")
            OpCodesList.Items.Add("10 : Comparrison. Is something (random number?) between A and B ")
            OpCodesList.Items.Add("11 : Check ObjVar.")
            OpCodesList.Items.Add("12 : Check Proximity and quest trigger hash in zone(not coded yet)")
            OpCodesList.Items.Add("13 : Select NPC number for use with ObjVar.")
            OpCodesList.Items.Add("14 : Check Quest Flag.")
            OpCodesList.Items.Add("15 : Unknown. Some sort of party check perhaps")
            OpCodesList.Items.Add("16 : Zone time??(not coded yet)")
            OpCodesList.Items.Add("17 : Compare ObjVar values for two NPCs (not coded yet)")
            OpCodesList.Items.Add("18 : Check Server time and date. TRUE if between time A and time B.")
            OpCodesList.Items.Add("19 : Check Server time and weekday. TRUE if between time A and time B.")
            OpCodesList.Items.Add("20 : Unknown. Appears to be comparing two values")
            OpCodesList.Items.Add("21 : Unknown. Include object type and radius")
            OpCodesList.Items.Add("22 : Unknown. includes X and Y coordinates.")
            OpCodesList.Items.Add("23 : Check Clan. Boolean btReg used to determine result IN or OUT.")
            OpCodesList.Items.Add("24 : Check my position in clan according to a value and a btOp control variable")
            OpCodesList.Items.Add("25 : Check my clan contribution according to a value and a btOp control variable")
            OpCodesList.Items.Add("26 : Check my clan grade according to a value and a btOp control variable")
            OpCodesList.Items.Add("27 : Check my clan points according to a value and a btOp control variable")
            OpCodesList.Items.Add("28 : Check my clan funds according to a value and a btOp control variable")
            OpCodesList.Items.Add("29 : Check my clan members according to a value and a btOp control variable")
            OpCodesList.Items.Add("30 : Check my clan skills according to 2 values and a btOp control variable")
            a = a
        Else
            OpCodesList.Items.Add("16777216 : Update Quest")
            OpCodesList.Items.Add("16777217 : Update Quest items")
            OpCodesList.Items.Add("16777218 : Set Quest variable")
            OpCodesList.Items.Add("16777219 : Update Stats")
            OpCodesList.Items.Add("16777220 : Set Quest variable")
            OpCodesList.Items.Add("16777221 : Give Quest reward")
            OpCodesList.Items.Add("16777222 : Restore HP/MP")
            OpCodesList.Items.Add("16777223 : Teleport to specified zone and coordinates")
            OpCodesList.Items.Add("16777224 : Spawn Monster(s)")
            OpCodesList.Items.Add("16777225 : Execute Quest trigger")
            OpCodesList.Items.Add("16777226 : Reset Stats")
            OpCodesList.Items.Add("16777227 : Set/Update ObjVar")
            OpCodesList.Items.Add("16777228 : NPC Speak/shout/Announce")
            OpCodesList.Items.Add("16777229 : Execute Quest Trigger (I think. not completely sure at this point)")
            OpCodesList.Items.Add("16777230 : learn Skill.")
            OpCodesList.Items.Add("16777231 : Set Quest flag.")
            OpCodesList.Items.Add("16777232 : Unknown. Something about groups??")
            OpCodesList.Items.Add("16777233 : Reset ALL Quest flags")
            OpCodesList.Items.Add("16777234 : Send Announcement")
            OpCodesList.Items.Add("16777235 : Execute Quest Trigger in another map. (performed by NPCs)")
            OpCodesList.Items.Add("16777236 : Set PVP status")
            OpCodesList.Items.Add("16777237 : Set respawn position")
            OpCodesList.Items.Add("16777238 : Unknown. (zone and btOp)")
            OpCodesList.Items.Add("16777239 : Raise Clan Grade")
            OpCodesList.Items.Add("16777240 : Adjust Clan funds. Value and btOp")
            OpCodesList.Items.Add("16777241 : Adjust Clan points. Value and btOp")
            OpCodesList.Items.Add("16777242 : Adjust Clan Skills. Value and btOp")
            OpCodesList.Items.Add("16777243 : Adjust Clan Contributions. Value and btOp")
            OpCodesList.Items.Add("16777244 : Clan teleport")
        End If
    End Sub

    Private Sub OpCodesList_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OpCodesList.SelectedIndexChanged
        Dim thisVal, ThisOp As String
        Dim a As Integer
        Dim ThisSplit() As String
        thisVal = OpCodesList.Text
        ThisSplit = Split(thisVal, " : ", -1)
        ThisOp = ThisSplit(0)
        If Form1.OpMode = 1 Then
            Form1.TextBox8.Text = ThisOp
        Else
            Form1.TextBox9.Text = ThisOp
        End If
        a = a
        Me.Hide()
        Me.Close()
    End Sub
End Class